#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 684
#define LARGE_STATE_COUNT 234
#define SYMBOL_COUNT 101
#define ALIAS_COUNT 0
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_symbol = 1,
  sym_line_comment = 2,
  anon_sym_LPAREN = 3,
  anon_sym_RPAREN = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_AT_LPAREN = 7,
  anon_sym_AT_LBRACK = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_AT_LBRACE = 11,
  anon_sym_set = 12,
  anon_sym_def = 13,
  anon_sym_var = 14,
  anon_sym_quote = 15,
  anon_sym_splice = 16,
  anon_sym_quasiquote = 17,
  anon_sym_unquote = 18,
  anon_sym_break = 19,
  anon_sym_if = 20,
  anon_sym_do = 21,
  anon_sym_while = 22,
  anon_sym_fn = 23,
  anon_sym_upscope = 24,
  sym_variadic_marker = 25,
  sym_optional_marker = 26,
  sym_keys_marker = 27,
  anon_sym_SQUOTE = 28,
  anon_sym_SEMI = 29,
  anon_sym_TILDE = 30,
  anon_sym_COMMA = 31,
  anon_sym_PIPE = 32,
  anon_sym_defn = 33,
  anon_sym_defn_DASH = 34,
  anon_sym_varfn = 35,
  anon_sym_varfn_DASH = 36,
  anon_sym_defmacro = 37,
  anon_sym_defmacro_DASH = 38,
  sym_str_literal = 39,
  sym_buffer_literal = 40,
  aux_sym_number_literal_token1 = 41,
  aux_sym_number_literal_token2 = 42,
  aux_sym_number_literal_token3 = 43,
  anon_sym_true = 44,
  anon_sym_false = 45,
  sym_nil_literal = 46,
  sym_escape_sequence = 47,
  sym_keyword = 48,
  sym__long_str = 49,
  sym__long_buffer = 50,
  sym_source_file = 51,
  sym__expr = 52,
  sym_tuple = 53,
  sym_sqr_tuple = 54,
  sym_array = 55,
  sym_sqr_array = 56,
  sym_struct = 57,
  sym_table = 58,
  sym__struct_tables_commom = 59,
  sym_peg_set = 60,
  sym__special_forms = 61,
  sym_def = 62,
  sym_var = 63,
  sym_quote = 64,
  sym_splice = 65,
  sym_quasiquote = 66,
  sym_unquote = 67,
  sym_break = 68,
  sym_set = 69,
  sym_if = 70,
  sym_do = 71,
  sym_while = 72,
  sym_fn = 73,
  sym_upscope = 74,
  sym__parameters = 75,
  sym_parameters = 76,
  sym_tuple_parameters = 77,
  sym__shorthand = 78,
  sym_short_quote = 79,
  sym_short_splice = 80,
  sym_short_quasiquote = 81,
  sym_short_unquote = 82,
  sym_short_fn = 83,
  sym__specials = 84,
  sym_extra_defs = 85,
  sym__literals = 86,
  sym_long_str_literal = 87,
  sym_long_buffer_literal = 88,
  sym_number_literal = 89,
  sym_bool_literal = 90,
  sym_metadata = 91,
  sym__name = 92,
  sym_body = 93,
  sym__identifier = 94,
  aux_sym_source_file_repeat1 = 95,
  aux_sym_tuple_repeat1 = 96,
  aux_sym_struct_repeat1 = 97,
  aux_sym_def_repeat1 = 98,
  aux_sym_while_repeat1 = 99,
  aux_sym_parameters_repeat1 = 100,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [sym_line_comment] = "line_comment",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACK] = "@[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_set] = "set",
  [anon_sym_def] = "def",
  [anon_sym_var] = "var",
  [anon_sym_quote] = "quote",
  [anon_sym_splice] = "splice",
  [anon_sym_quasiquote] = "quasiquote",
  [anon_sym_unquote] = "unquote",
  [anon_sym_break] = "break",
  [anon_sym_if] = "if",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_fn] = "fn",
  [anon_sym_upscope] = "upscope",
  [sym_variadic_marker] = "variadic_marker",
  [sym_optional_marker] = "optional_marker",
  [sym_keys_marker] = "keys_marker",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_SEMI] = ";",
  [anon_sym_TILDE] = "~",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_defn] = "defn",
  [anon_sym_defn_DASH] = "defn-",
  [anon_sym_varfn] = "varfn",
  [anon_sym_varfn_DASH] = "varfn-",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defmacro_DASH] = "defmacro-",
  [sym_str_literal] = "str_literal",
  [sym_buffer_literal] = "buffer_literal",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_nil_literal] = "nil_literal",
  [sym_escape_sequence] = "escape_sequence",
  [sym_keyword] = "keyword",
  [sym__long_str] = "_long_str",
  [sym__long_buffer] = "_long_buffer",
  [sym_source_file] = "source_file",
  [sym__expr] = "_expr",
  [sym_tuple] = "tuple",
  [sym_sqr_tuple] = "sqr_tuple",
  [sym_array] = "array",
  [sym_sqr_array] = "sqr_array",
  [sym_struct] = "struct",
  [sym_table] = "table",
  [sym__struct_tables_commom] = "_struct_tables_commom",
  [sym_peg_set] = "peg_set",
  [sym__special_forms] = "_special_forms",
  [sym_def] = "def",
  [sym_var] = "var",
  [sym_quote] = "quote",
  [sym_splice] = "splice",
  [sym_quasiquote] = "quasiquote",
  [sym_unquote] = "unquote",
  [sym_break] = "break",
  [sym_set] = "set",
  [sym_if] = "if",
  [sym_do] = "do",
  [sym_while] = "while",
  [sym_fn] = "fn",
  [sym_upscope] = "upscope",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_tuple_parameters] = "tuple_parameters",
  [sym__shorthand] = "_shorthand",
  [sym_short_quote] = "short_quote",
  [sym_short_splice] = "short_splice",
  [sym_short_quasiquote] = "short_quasiquote",
  [sym_short_unquote] = "short_unquote",
  [sym_short_fn] = "short_fn",
  [sym__specials] = "_specials",
  [sym_extra_defs] = "extra_defs",
  [sym__literals] = "_literals",
  [sym_long_str_literal] = "long_str_literal",
  [sym_long_buffer_literal] = "long_buffer_literal",
  [sym_number_literal] = "number_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_metadata] = "metadata",
  [sym__name] = "_name",
  [sym_body] = "body",
  [sym__identifier] = "_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_def_repeat1] = "def_repeat1",
  [aux_sym_while_repeat1] = "while_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_splice] = anon_sym_splice,
  [anon_sym_quasiquote] = anon_sym_quasiquote,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_upscope] = anon_sym_upscope,
  [sym_variadic_marker] = sym_variadic_marker,
  [sym_optional_marker] = sym_optional_marker,
  [sym_keys_marker] = sym_keys_marker,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_defn] = anon_sym_defn,
  [anon_sym_defn_DASH] = anon_sym_defn_DASH,
  [anon_sym_varfn] = anon_sym_varfn,
  [anon_sym_varfn_DASH] = anon_sym_varfn_DASH,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defmacro_DASH] = anon_sym_defmacro_DASH,
  [sym_str_literal] = sym_str_literal,
  [sym_buffer_literal] = sym_buffer_literal,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_nil_literal] = sym_nil_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_keyword] = sym_keyword,
  [sym__long_str] = sym__long_str,
  [sym__long_buffer] = sym__long_buffer,
  [sym_source_file] = sym_source_file,
  [sym__expr] = sym__expr,
  [sym_tuple] = sym_tuple,
  [sym_sqr_tuple] = sym_sqr_tuple,
  [sym_array] = sym_array,
  [sym_sqr_array] = sym_sqr_array,
  [sym_struct] = sym_struct,
  [sym_table] = sym_table,
  [sym__struct_tables_commom] = sym__struct_tables_commom,
  [sym_peg_set] = sym_peg_set,
  [sym__special_forms] = sym__special_forms,
  [sym_def] = sym_def,
  [sym_var] = sym_var,
  [sym_quote] = sym_quote,
  [sym_splice] = sym_splice,
  [sym_quasiquote] = sym_quasiquote,
  [sym_unquote] = sym_unquote,
  [sym_break] = sym_break,
  [sym_set] = sym_set,
  [sym_if] = sym_if,
  [sym_do] = sym_do,
  [sym_while] = sym_while,
  [sym_fn] = sym_fn,
  [sym_upscope] = sym_upscope,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_tuple_parameters] = sym_tuple_parameters,
  [sym__shorthand] = sym__shorthand,
  [sym_short_quote] = sym_short_quote,
  [sym_short_splice] = sym_short_splice,
  [sym_short_quasiquote] = sym_short_quasiquote,
  [sym_short_unquote] = sym_short_unquote,
  [sym_short_fn] = sym_short_fn,
  [sym__specials] = sym__specials,
  [sym_extra_defs] = sym_extra_defs,
  [sym__literals] = sym__literals,
  [sym_long_str_literal] = sym_long_str_literal,
  [sym_long_buffer_literal] = sym_long_buffer_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_metadata] = sym_metadata,
  [sym__name] = sym__name,
  [sym_body] = sym_body,
  [sym__identifier] = sym__identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_def_repeat1] = aux_sym_def_repeat1,
  [aux_sym_while_repeat1] = aux_sym_while_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_splice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quasiquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upscope] = {
    .visible = true,
    .named = false,
  },
  [sym_variadic_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_keys_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__long_str] = {
    .visible = false,
    .named = true,
  },
  [sym__long_buffer] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_array] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_tables_commom] = {
    .visible = false,
    .named = true,
  },
  [sym_peg_set] = {
    .visible = true,
    .named = true,
  },
  [sym__special_forms] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym_upscope] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__shorthand] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_short_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_short_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__specials] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_extra_defs] = {
    .visible = true,
    .named = true,
  },
  [sym__literals] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_long_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_long_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_body = 1,
  field_condition = 2,
  field_else = 3,
  field_form = 4,
  field_item = 5,
  field_key = 6,
  field_l_value = 7,
  field_metadata = 8,
  field_name = 9,
  field_parameter = 10,
  field_parameters = 11,
  field_r_value = 12,
  field_then = 13,
  field_value = 14,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_form] = "form",
  [field_item] = "item",
  [field_key] = "key",
  [field_l_value] = "l_value",
  [field_metadata] = "metadata",
  [field_name] = "name",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_r_value] = "r_value",
  [field_then] = "then",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[32] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 2},
  [9] = {.index = 11, .length = 2},
  [10] = {.index = 13, .length = 4},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 2},
  [18] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 2},
  [21] = {.index = 32, .length = 2},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 2},
  [24] = {.index = 38, .length = 2},
  [25] = {.index = 40, .length = 3},
  [26] = {.index = 43, .length = 3},
  [27] = {.index = 46, .length = 1},
  [28] = {.index = 47, .length = 3},
  [29] = {.index = 50, .length = 3},
  [30] = {.index = 53, .length = 2},
  [31] = {.index = 55, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_item, 0},
  [1] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_form, 0},
  [5] =
    {field_form, 0, .inherited = true},
  [6] =
    {field_item, 1, .inherited = true},
  [7] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [9] =
    {field_key, 0},
    {field_value, 1},
  [11] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [13] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [17] =
    {field_metadata, 0},
  [18] =
    {field_body, 2},
  [19] =
    {field_form, 0, .inherited = true},
    {field_form, 1, .inherited = true},
  [21] =
    {field_condition, 2},
  [22] =
    {field_parameter, 0},
  [23] =
    {field_parameters, 2},
  [24] =
    {field_l_value, 2},
    {field_r_value, 3},
  [26] =
    {field_name, 2},
    {field_value, 3},
  [28] =
    {field_metadata, 0, .inherited = true},
    {field_metadata, 1, .inherited = true},
  [30] =
    {field_condition, 2},
    {field_then, 3},
  [32] =
    {field_condition, 2},
    {field_form, 3, .inherited = true},
  [34] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [36] =
    {field_body, 3},
    {field_parameters, 2},
  [38] =
    {field_name, 2},
    {field_parameters, 3},
  [40] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_value, 4},
  [43] =
    {field_condition, 2},
    {field_else, 4},
    {field_then, 3},
  [46] =
    {field_parameter, 2, .inherited = true},
  [47] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [50] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
  [53] =
    {field_parameter, 1, .inherited = true},
    {field_parameter, 3, .inherited = true},
  [55] =
    {field_body, 5},
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
};

static TSSymbol ts_alias_sequences[32][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_symbol_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_2(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? c == ','
        : c <= ';')
      : (c <= '[' || (c < '`'
        ? c == ']'
        : c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(44);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(7);
      if (lookahead == 'x') ADVANCE(18);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == 'x') ADVANCE(19);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == '{') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 8:
      if (lookahead == '{') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 22:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_variadic_marker);
      if (lookahead == 'k') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_optional_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_keys_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_str_literal);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_buffer_literal);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'x') ADVANCE(63);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '.') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_keyword);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '(') ADVANCE(30);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '{') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(83);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'e') ADVANCE(69);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'p') ADVANCE(67);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 's') ADVANCE(37);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 't') ADVANCE(36);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'x') ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(57);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'y') ADVANCE(66);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(83);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_symbol);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'n') ADVANCE(5);
      if (lookahead == 'q') ADVANCE(6);
      if (lookahead == 's') ADVANCE(7);
      if (lookahead == 't') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'v') ADVANCE(10);
      if (lookahead == 'w') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'p') ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 18:
      if (lookahead == 'l') ADVANCE(30);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(33);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 23:
      if (lookahead == 'q') ADVANCE(36);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(40);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nil_literal);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(49);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'k') ADVANCE(52);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_defn);
      if (lookahead == '-') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(58);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(61);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(63);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_defn_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_varfn);
      if (lookahead == '-') ADVANCE(68);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(69);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_splice);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_varfn_DASH);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_unquote);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_upscope);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if (lookahead == '-') ADVANCE(75);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_defmacro_DASH);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_quasiquote);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 22, .external_lex_state = 1},
  [2] = {.lex_state = 22, .external_lex_state = 1},
  [3] = {.lex_state = 22, .external_lex_state = 1},
  [4] = {.lex_state = 22, .external_lex_state = 1},
  [5] = {.lex_state = 22, .external_lex_state = 1},
  [6] = {.lex_state = 22, .external_lex_state = 1},
  [7] = {.lex_state = 22, .external_lex_state = 1},
  [8] = {.lex_state = 1, .external_lex_state = 1},
  [9] = {.lex_state = 1, .external_lex_state = 1},
  [10] = {.lex_state = 1, .external_lex_state = 1},
  [11] = {.lex_state = 1, .external_lex_state = 1},
  [12] = {.lex_state = 1, .external_lex_state = 1},
  [13] = {.lex_state = 22, .external_lex_state = 1},
  [14] = {.lex_state = 22, .external_lex_state = 1},
  [15] = {.lex_state = 22, .external_lex_state = 1},
  [16] = {.lex_state = 22, .external_lex_state = 1},
  [17] = {.lex_state = 22, .external_lex_state = 1},
  [18] = {.lex_state = 22, .external_lex_state = 1},
  [19] = {.lex_state = 22, .external_lex_state = 1},
  [20] = {.lex_state = 22, .external_lex_state = 1},
  [21] = {.lex_state = 22, .external_lex_state = 1},
  [22] = {.lex_state = 22, .external_lex_state = 1},
  [23] = {.lex_state = 22, .external_lex_state = 1},
  [24] = {.lex_state = 22, .external_lex_state = 1},
  [25] = {.lex_state = 22, .external_lex_state = 1},
  [26] = {.lex_state = 22, .external_lex_state = 1},
  [27] = {.lex_state = 22, .external_lex_state = 1},
  [28] = {.lex_state = 22, .external_lex_state = 1},
  [29] = {.lex_state = 22, .external_lex_state = 1},
  [30] = {.lex_state = 22, .external_lex_state = 1},
  [31] = {.lex_state = 22, .external_lex_state = 1},
  [32] = {.lex_state = 22, .external_lex_state = 1},
  [33] = {.lex_state = 22, .external_lex_state = 1},
  [34] = {.lex_state = 22, .external_lex_state = 1},
  [35] = {.lex_state = 22, .external_lex_state = 1},
  [36] = {.lex_state = 22, .external_lex_state = 1},
  [37] = {.lex_state = 22, .external_lex_state = 1},
  [38] = {.lex_state = 22, .external_lex_state = 1},
  [39] = {.lex_state = 22, .external_lex_state = 1},
  [40] = {.lex_state = 22, .external_lex_state = 1},
  [41] = {.lex_state = 22, .external_lex_state = 1},
  [42] = {.lex_state = 22, .external_lex_state = 1},
  [43] = {.lex_state = 22, .external_lex_state = 1},
  [44] = {.lex_state = 22, .external_lex_state = 1},
  [45] = {.lex_state = 22, .external_lex_state = 1},
  [46] = {.lex_state = 22, .external_lex_state = 1},
  [47] = {.lex_state = 22, .external_lex_state = 1},
  [48] = {.lex_state = 22, .external_lex_state = 1},
  [49] = {.lex_state = 22, .external_lex_state = 1},
  [50] = {.lex_state = 22, .external_lex_state = 1},
  [51] = {.lex_state = 22, .external_lex_state = 1},
  [52] = {.lex_state = 22, .external_lex_state = 1},
  [53] = {.lex_state = 22, .external_lex_state = 1},
  [54] = {.lex_state = 22, .external_lex_state = 1},
  [55] = {.lex_state = 22, .external_lex_state = 1},
  [56] = {.lex_state = 22, .external_lex_state = 1},
  [57] = {.lex_state = 22, .external_lex_state = 1},
  [58] = {.lex_state = 22, .external_lex_state = 1},
  [59] = {.lex_state = 22, .external_lex_state = 1},
  [60] = {.lex_state = 22, .external_lex_state = 1},
  [61] = {.lex_state = 22, .external_lex_state = 1},
  [62] = {.lex_state = 22, .external_lex_state = 1},
  [63] = {.lex_state = 22, .external_lex_state = 1},
  [64] = {.lex_state = 22, .external_lex_state = 1},
  [65] = {.lex_state = 22, .external_lex_state = 1},
  [66] = {.lex_state = 22, .external_lex_state = 1},
  [67] = {.lex_state = 22, .external_lex_state = 1},
  [68] = {.lex_state = 22, .external_lex_state = 1},
  [69] = {.lex_state = 22, .external_lex_state = 1},
  [70] = {.lex_state = 22, .external_lex_state = 1},
  [71] = {.lex_state = 22, .external_lex_state = 1},
  [72] = {.lex_state = 22, .external_lex_state = 1},
  [73] = {.lex_state = 22, .external_lex_state = 1},
  [74] = {.lex_state = 22, .external_lex_state = 1},
  [75] = {.lex_state = 22, .external_lex_state = 1},
  [76] = {.lex_state = 22, .external_lex_state = 1},
  [77] = {.lex_state = 22, .external_lex_state = 1},
  [78] = {.lex_state = 22, .external_lex_state = 1},
  [79] = {.lex_state = 22, .external_lex_state = 1},
  [80] = {.lex_state = 22, .external_lex_state = 1},
  [81] = {.lex_state = 22, .external_lex_state = 1},
  [82] = {.lex_state = 22, .external_lex_state = 1},
  [83] = {.lex_state = 22, .external_lex_state = 1},
  [84] = {.lex_state = 22, .external_lex_state = 1},
  [85] = {.lex_state = 22, .external_lex_state = 1},
  [86] = {.lex_state = 22, .external_lex_state = 1},
  [87] = {.lex_state = 22, .external_lex_state = 1},
  [88] = {.lex_state = 22, .external_lex_state = 1},
  [89] = {.lex_state = 22, .external_lex_state = 1},
  [90] = {.lex_state = 22, .external_lex_state = 1},
  [91] = {.lex_state = 22, .external_lex_state = 1},
  [92] = {.lex_state = 22, .external_lex_state = 1},
  [93] = {.lex_state = 22, .external_lex_state = 1},
  [94] = {.lex_state = 22, .external_lex_state = 1},
  [95] = {.lex_state = 22, .external_lex_state = 1},
  [96] = {.lex_state = 22, .external_lex_state = 1},
  [97] = {.lex_state = 22, .external_lex_state = 1},
  [98] = {.lex_state = 22, .external_lex_state = 1},
  [99] = {.lex_state = 22, .external_lex_state = 1},
  [100] = {.lex_state = 22, .external_lex_state = 1},
  [101] = {.lex_state = 22, .external_lex_state = 1},
  [102] = {.lex_state = 22, .external_lex_state = 1},
  [103] = {.lex_state = 22, .external_lex_state = 1},
  [104] = {.lex_state = 22, .external_lex_state = 1},
  [105] = {.lex_state = 22, .external_lex_state = 1},
  [106] = {.lex_state = 22, .external_lex_state = 1},
  [107] = {.lex_state = 22, .external_lex_state = 1},
  [108] = {.lex_state = 22, .external_lex_state = 1},
  [109] = {.lex_state = 22, .external_lex_state = 1},
  [110] = {.lex_state = 22, .external_lex_state = 1},
  [111] = {.lex_state = 22, .external_lex_state = 1},
  [112] = {.lex_state = 22, .external_lex_state = 1},
  [113] = {.lex_state = 22, .external_lex_state = 1},
  [114] = {.lex_state = 22, .external_lex_state = 1},
  [115] = {.lex_state = 22, .external_lex_state = 1},
  [116] = {.lex_state = 22, .external_lex_state = 1},
  [117] = {.lex_state = 22, .external_lex_state = 1},
  [118] = {.lex_state = 22, .external_lex_state = 1},
  [119] = {.lex_state = 22, .external_lex_state = 1},
  [120] = {.lex_state = 22, .external_lex_state = 1},
  [121] = {.lex_state = 22, .external_lex_state = 1},
  [122] = {.lex_state = 22, .external_lex_state = 1},
  [123] = {.lex_state = 22, .external_lex_state = 1},
  [124] = {.lex_state = 22, .external_lex_state = 1},
  [125] = {.lex_state = 22, .external_lex_state = 1},
  [126] = {.lex_state = 22, .external_lex_state = 1},
  [127] = {.lex_state = 22, .external_lex_state = 1},
  [128] = {.lex_state = 22, .external_lex_state = 1},
  [129] = {.lex_state = 22, .external_lex_state = 1},
  [130] = {.lex_state = 22, .external_lex_state = 1},
  [131] = {.lex_state = 22, .external_lex_state = 1},
  [132] = {.lex_state = 22, .external_lex_state = 1},
  [133] = {.lex_state = 22, .external_lex_state = 1},
  [134] = {.lex_state = 22, .external_lex_state = 1},
  [135] = {.lex_state = 22, .external_lex_state = 1},
  [136] = {.lex_state = 22, .external_lex_state = 1},
  [137] = {.lex_state = 22, .external_lex_state = 1},
  [138] = {.lex_state = 22, .external_lex_state = 1},
  [139] = {.lex_state = 22, .external_lex_state = 1},
  [140] = {.lex_state = 22, .external_lex_state = 1},
  [141] = {.lex_state = 22, .external_lex_state = 1},
  [142] = {.lex_state = 22, .external_lex_state = 1},
  [143] = {.lex_state = 22, .external_lex_state = 1},
  [144] = {.lex_state = 22, .external_lex_state = 1},
  [145] = {.lex_state = 22, .external_lex_state = 1},
  [146] = {.lex_state = 22, .external_lex_state = 1},
  [147] = {.lex_state = 22, .external_lex_state = 1},
  [148] = {.lex_state = 22, .external_lex_state = 1},
  [149] = {.lex_state = 22, .external_lex_state = 1},
  [150] = {.lex_state = 22, .external_lex_state = 1},
  [151] = {.lex_state = 22, .external_lex_state = 1},
  [152] = {.lex_state = 22, .external_lex_state = 1},
  [153] = {.lex_state = 22, .external_lex_state = 1},
  [154] = {.lex_state = 22, .external_lex_state = 1},
  [155] = {.lex_state = 22, .external_lex_state = 1},
  [156] = {.lex_state = 22, .external_lex_state = 1},
  [157] = {.lex_state = 22, .external_lex_state = 1},
  [158] = {.lex_state = 22, .external_lex_state = 1},
  [159] = {.lex_state = 22, .external_lex_state = 1},
  [160] = {.lex_state = 22, .external_lex_state = 1},
  [161] = {.lex_state = 22, .external_lex_state = 1},
  [162] = {.lex_state = 22, .external_lex_state = 1},
  [163] = {.lex_state = 22, .external_lex_state = 1},
  [164] = {.lex_state = 22, .external_lex_state = 1},
  [165] = {.lex_state = 22, .external_lex_state = 1},
  [166] = {.lex_state = 22, .external_lex_state = 1},
  [167] = {.lex_state = 22, .external_lex_state = 1},
  [168] = {.lex_state = 22, .external_lex_state = 1},
  [169] = {.lex_state = 22, .external_lex_state = 1},
  [170] = {.lex_state = 22, .external_lex_state = 1},
  [171] = {.lex_state = 22, .external_lex_state = 1},
  [172] = {.lex_state = 22, .external_lex_state = 1},
  [173] = {.lex_state = 22, .external_lex_state = 1},
  [174] = {.lex_state = 22, .external_lex_state = 1},
  [175] = {.lex_state = 22, .external_lex_state = 1},
  [176] = {.lex_state = 22, .external_lex_state = 1},
  [177] = {.lex_state = 22, .external_lex_state = 1},
  [178] = {.lex_state = 22, .external_lex_state = 1},
  [179] = {.lex_state = 22, .external_lex_state = 1},
  [180] = {.lex_state = 22, .external_lex_state = 1},
  [181] = {.lex_state = 22, .external_lex_state = 1},
  [182] = {.lex_state = 22, .external_lex_state = 1},
  [183] = {.lex_state = 22, .external_lex_state = 1},
  [184] = {.lex_state = 22, .external_lex_state = 1},
  [185] = {.lex_state = 22, .external_lex_state = 1},
  [186] = {.lex_state = 22, .external_lex_state = 1},
  [187] = {.lex_state = 22, .external_lex_state = 1},
  [188] = {.lex_state = 22, .external_lex_state = 1},
  [189] = {.lex_state = 22, .external_lex_state = 1},
  [190] = {.lex_state = 22, .external_lex_state = 1},
  [191] = {.lex_state = 22, .external_lex_state = 1},
  [192] = {.lex_state = 22, .external_lex_state = 1},
  [193] = {.lex_state = 22, .external_lex_state = 1},
  [194] = {.lex_state = 22, .external_lex_state = 1},
  [195] = {.lex_state = 22, .external_lex_state = 1},
  [196] = {.lex_state = 22, .external_lex_state = 1},
  [197] = {.lex_state = 22, .external_lex_state = 1},
  [198] = {.lex_state = 22, .external_lex_state = 1},
  [199] = {.lex_state = 22, .external_lex_state = 1},
  [200] = {.lex_state = 22, .external_lex_state = 1},
  [201] = {.lex_state = 22, .external_lex_state = 1},
  [202] = {.lex_state = 22, .external_lex_state = 1},
  [203] = {.lex_state = 22, .external_lex_state = 1},
  [204] = {.lex_state = 22, .external_lex_state = 1},
  [205] = {.lex_state = 22, .external_lex_state = 1},
  [206] = {.lex_state = 22, .external_lex_state = 1},
  [207] = {.lex_state = 22, .external_lex_state = 1},
  [208] = {.lex_state = 22, .external_lex_state = 1},
  [209] = {.lex_state = 22, .external_lex_state = 1},
  [210] = {.lex_state = 22, .external_lex_state = 1},
  [211] = {.lex_state = 22, .external_lex_state = 1},
  [212] = {.lex_state = 22, .external_lex_state = 1},
  [213] = {.lex_state = 22, .external_lex_state = 1},
  [214] = {.lex_state = 22, .external_lex_state = 1},
  [215] = {.lex_state = 22, .external_lex_state = 1},
  [216] = {.lex_state = 22, .external_lex_state = 1},
  [217] = {.lex_state = 22, .external_lex_state = 1},
  [218] = {.lex_state = 22, .external_lex_state = 1},
  [219] = {.lex_state = 22, .external_lex_state = 1},
  [220] = {.lex_state = 22, .external_lex_state = 1},
  [221] = {.lex_state = 22, .external_lex_state = 1},
  [222] = {.lex_state = 22, .external_lex_state = 1},
  [223] = {.lex_state = 22, .external_lex_state = 1},
  [224] = {.lex_state = 22, .external_lex_state = 1},
  [225] = {.lex_state = 22, .external_lex_state = 1},
  [226] = {.lex_state = 22, .external_lex_state = 1},
  [227] = {.lex_state = 22, .external_lex_state = 1},
  [228] = {.lex_state = 22, .external_lex_state = 1},
  [229] = {.lex_state = 22, .external_lex_state = 1},
  [230] = {.lex_state = 22, .external_lex_state = 1},
  [231] = {.lex_state = 22, .external_lex_state = 1},
  [232] = {.lex_state = 22, .external_lex_state = 1},
  [233] = {.lex_state = 22, .external_lex_state = 1},
  [234] = {.lex_state = 22, .external_lex_state = 1},
  [235] = {.lex_state = 1, .external_lex_state = 1},
  [236] = {.lex_state = 1, .external_lex_state = 1},
  [237] = {.lex_state = 1, .external_lex_state = 1},
  [238] = {.lex_state = 1, .external_lex_state = 1},
  [239] = {.lex_state = 1, .external_lex_state = 1},
  [240] = {.lex_state = 1, .external_lex_state = 1},
  [241] = {.lex_state = 1, .external_lex_state = 1},
  [242] = {.lex_state = 1, .external_lex_state = 1},
  [243] = {.lex_state = 1, .external_lex_state = 1},
  [244] = {.lex_state = 1, .external_lex_state = 1},
  [245] = {.lex_state = 1, .external_lex_state = 1},
  [246] = {.lex_state = 1, .external_lex_state = 1},
  [247] = {.lex_state = 1, .external_lex_state = 1},
  [248] = {.lex_state = 1, .external_lex_state = 1},
  [249] = {.lex_state = 1, .external_lex_state = 1},
  [250] = {.lex_state = 1, .external_lex_state = 1},
  [251] = {.lex_state = 1, .external_lex_state = 1},
  [252] = {.lex_state = 1, .external_lex_state = 1},
  [253] = {.lex_state = 1, .external_lex_state = 1},
  [254] = {.lex_state = 1, .external_lex_state = 1},
  [255] = {.lex_state = 1, .external_lex_state = 1},
  [256] = {.lex_state = 1, .external_lex_state = 1},
  [257] = {.lex_state = 1, .external_lex_state = 1},
  [258] = {.lex_state = 1, .external_lex_state = 1},
  [259] = {.lex_state = 1, .external_lex_state = 1},
  [260] = {.lex_state = 1, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 1, .external_lex_state = 1},
  [263] = {.lex_state = 1, .external_lex_state = 1},
  [264] = {.lex_state = 1, .external_lex_state = 1},
  [265] = {.lex_state = 1, .external_lex_state = 1},
  [266] = {.lex_state = 1, .external_lex_state = 1},
  [267] = {.lex_state = 1, .external_lex_state = 1},
  [268] = {.lex_state = 1, .external_lex_state = 1},
  [269] = {.lex_state = 1, .external_lex_state = 1},
  [270] = {.lex_state = 1, .external_lex_state = 1},
  [271] = {.lex_state = 1, .external_lex_state = 1},
  [272] = {.lex_state = 1, .external_lex_state = 1},
  [273] = {.lex_state = 1, .external_lex_state = 1},
  [274] = {.lex_state = 1, .external_lex_state = 1},
  [275] = {.lex_state = 1, .external_lex_state = 1},
  [276] = {.lex_state = 1, .external_lex_state = 1},
  [277] = {.lex_state = 1, .external_lex_state = 1},
  [278] = {.lex_state = 1, .external_lex_state = 1},
  [279] = {.lex_state = 1, .external_lex_state = 1},
  [280] = {.lex_state = 1, .external_lex_state = 1},
  [281] = {.lex_state = 1, .external_lex_state = 1},
  [282] = {.lex_state = 1, .external_lex_state = 1},
  [283] = {.lex_state = 1, .external_lex_state = 1},
  [284] = {.lex_state = 1, .external_lex_state = 1},
  [285] = {.lex_state = 1, .external_lex_state = 1},
  [286] = {.lex_state = 1, .external_lex_state = 1},
  [287] = {.lex_state = 1, .external_lex_state = 1},
  [288] = {.lex_state = 1, .external_lex_state = 1},
  [289] = {.lex_state = 1, .external_lex_state = 1},
  [290] = {.lex_state = 1, .external_lex_state = 1},
  [291] = {.lex_state = 1, .external_lex_state = 1},
  [292] = {.lex_state = 1, .external_lex_state = 1},
  [293] = {.lex_state = 1, .external_lex_state = 1},
  [294] = {.lex_state = 1, .external_lex_state = 1},
  [295] = {.lex_state = 22, .external_lex_state = 1},
  [296] = {.lex_state = 22, .external_lex_state = 1},
  [297] = {.lex_state = 22, .external_lex_state = 1},
  [298] = {.lex_state = 22, .external_lex_state = 1},
  [299] = {.lex_state = 22, .external_lex_state = 1},
  [300] = {.lex_state = 22, .external_lex_state = 1},
  [301] = {.lex_state = 22, .external_lex_state = 1},
  [302] = {.lex_state = 22, .external_lex_state = 1},
  [303] = {.lex_state = 22, .external_lex_state = 1},
  [304] = {.lex_state = 22, .external_lex_state = 1},
  [305] = {.lex_state = 22, .external_lex_state = 1},
  [306] = {.lex_state = 22, .external_lex_state = 1},
  [307] = {.lex_state = 22, .external_lex_state = 1},
  [308] = {.lex_state = 22, .external_lex_state = 1},
  [309] = {.lex_state = 22, .external_lex_state = 1},
  [310] = {.lex_state = 22, .external_lex_state = 1},
  [311] = {.lex_state = 22, .external_lex_state = 1},
  [312] = {.lex_state = 22, .external_lex_state = 1},
  [313] = {.lex_state = 22, .external_lex_state = 1},
  [314] = {.lex_state = 22, .external_lex_state = 1},
  [315] = {.lex_state = 22, .external_lex_state = 1},
  [316] = {.lex_state = 22, .external_lex_state = 1},
  [317] = {.lex_state = 22, .external_lex_state = 1},
  [318] = {.lex_state = 22, .external_lex_state = 1},
  [319] = {.lex_state = 22, .external_lex_state = 1},
  [320] = {.lex_state = 22, .external_lex_state = 1},
  [321] = {.lex_state = 22, .external_lex_state = 1},
  [322] = {.lex_state = 22, .external_lex_state = 1},
  [323] = {.lex_state = 22, .external_lex_state = 1},
  [324] = {.lex_state = 22, .external_lex_state = 1},
  [325] = {.lex_state = 22, .external_lex_state = 1},
  [326] = {.lex_state = 22, .external_lex_state = 1},
  [327] = {.lex_state = 22, .external_lex_state = 1},
  [328] = {.lex_state = 22, .external_lex_state = 1},
  [329] = {.lex_state = 22, .external_lex_state = 1},
  [330] = {.lex_state = 22, .external_lex_state = 1},
  [331] = {.lex_state = 22, .external_lex_state = 1},
  [332] = {.lex_state = 22, .external_lex_state = 1},
  [333] = {.lex_state = 22, .external_lex_state = 1},
  [334] = {.lex_state = 22, .external_lex_state = 1},
  [335] = {.lex_state = 22, .external_lex_state = 1},
  [336] = {.lex_state = 22, .external_lex_state = 1},
  [337] = {.lex_state = 22, .external_lex_state = 1},
  [338] = {.lex_state = 22, .external_lex_state = 1},
  [339] = {.lex_state = 22, .external_lex_state = 1},
  [340] = {.lex_state = 22, .external_lex_state = 1},
  [341] = {.lex_state = 22, .external_lex_state = 1},
  [342] = {.lex_state = 22, .external_lex_state = 1},
  [343] = {.lex_state = 22, .external_lex_state = 1},
  [344] = {.lex_state = 22, .external_lex_state = 1},
  [345] = {.lex_state = 22, .external_lex_state = 1},
  [346] = {.lex_state = 22, .external_lex_state = 1},
  [347] = {.lex_state = 22, .external_lex_state = 1},
  [348] = {.lex_state = 22, .external_lex_state = 1},
  [349] = {.lex_state = 22, .external_lex_state = 1},
  [350] = {.lex_state = 22, .external_lex_state = 1},
  [351] = {.lex_state = 22, .external_lex_state = 1},
  [352] = {.lex_state = 22, .external_lex_state = 1},
  [353] = {.lex_state = 22, .external_lex_state = 1},
  [354] = {.lex_state = 2, .external_lex_state = 2},
  [355] = {.lex_state = 2, .external_lex_state = 2},
  [356] = {.lex_state = 2, .external_lex_state = 2},
  [357] = {.lex_state = 2, .external_lex_state = 2},
  [358] = {.lex_state = 2, .external_lex_state = 2},
  [359] = {.lex_state = 2, .external_lex_state = 2},
  [360] = {.lex_state = 2, .external_lex_state = 2},
  [361] = {.lex_state = 2, .external_lex_state = 2},
  [362] = {.lex_state = 22, .external_lex_state = 1},
  [363] = {.lex_state = 2, .external_lex_state = 2},
  [364] = {.lex_state = 22, .external_lex_state = 1},
  [365] = {.lex_state = 2, .external_lex_state = 2},
  [366] = {.lex_state = 22, .external_lex_state = 1},
  [367] = {.lex_state = 22, .external_lex_state = 1},
  [368] = {.lex_state = 22, .external_lex_state = 1},
  [369] = {.lex_state = 22, .external_lex_state = 1},
  [370] = {.lex_state = 22, .external_lex_state = 1},
  [371] = {.lex_state = 22, .external_lex_state = 1},
  [372] = {.lex_state = 22, .external_lex_state = 1},
  [373] = {.lex_state = 22, .external_lex_state = 1},
  [374] = {.lex_state = 22, .external_lex_state = 1},
  [375] = {.lex_state = 22, .external_lex_state = 1},
  [376] = {.lex_state = 22, .external_lex_state = 1},
  [377] = {.lex_state = 22, .external_lex_state = 1},
  [378] = {.lex_state = 22, .external_lex_state = 1},
  [379] = {.lex_state = 22, .external_lex_state = 1},
  [380] = {.lex_state = 22, .external_lex_state = 1},
  [381] = {.lex_state = 22, .external_lex_state = 1},
  [382] = {.lex_state = 22, .external_lex_state = 1},
  [383] = {.lex_state = 22, .external_lex_state = 1},
  [384] = {.lex_state = 22, .external_lex_state = 1},
  [385] = {.lex_state = 22, .external_lex_state = 1},
  [386] = {.lex_state = 22, .external_lex_state = 1},
  [387] = {.lex_state = 22, .external_lex_state = 1},
  [388] = {.lex_state = 22, .external_lex_state = 1},
  [389] = {.lex_state = 22, .external_lex_state = 1},
  [390] = {.lex_state = 22, .external_lex_state = 1},
  [391] = {.lex_state = 22, .external_lex_state = 1},
  [392] = {.lex_state = 22, .external_lex_state = 1},
  [393] = {.lex_state = 22, .external_lex_state = 1},
  [394] = {.lex_state = 22, .external_lex_state = 1},
  [395] = {.lex_state = 22, .external_lex_state = 1},
  [396] = {.lex_state = 22, .external_lex_state = 1},
  [397] = {.lex_state = 22, .external_lex_state = 1},
  [398] = {.lex_state = 22, .external_lex_state = 1},
  [399] = {.lex_state = 22, .external_lex_state = 1},
  [400] = {.lex_state = 22, .external_lex_state = 1},
  [401] = {.lex_state = 22, .external_lex_state = 1},
  [402] = {.lex_state = 22, .external_lex_state = 1},
  [403] = {.lex_state = 22, .external_lex_state = 1},
  [404] = {.lex_state = 22, .external_lex_state = 1},
  [405] = {.lex_state = 22, .external_lex_state = 1},
  [406] = {.lex_state = 22, .external_lex_state = 1},
  [407] = {.lex_state = 22, .external_lex_state = 1},
  [408] = {.lex_state = 22, .external_lex_state = 1},
  [409] = {.lex_state = 22, .external_lex_state = 1},
  [410] = {.lex_state = 22, .external_lex_state = 1},
  [411] = {.lex_state = 22, .external_lex_state = 1},
  [412] = {.lex_state = 22, .external_lex_state = 1},
  [413] = {.lex_state = 22, .external_lex_state = 1},
  [414] = {.lex_state = 22, .external_lex_state = 1},
  [415] = {.lex_state = 22, .external_lex_state = 1},
  [416] = {.lex_state = 22, .external_lex_state = 1},
  [417] = {.lex_state = 22, .external_lex_state = 1},
  [418] = {.lex_state = 22, .external_lex_state = 1},
  [419] = {.lex_state = 22, .external_lex_state = 1},
  [420] = {.lex_state = 22, .external_lex_state = 1},
  [421] = {.lex_state = 22, .external_lex_state = 1},
  [422] = {.lex_state = 22, .external_lex_state = 1},
  [423] = {.lex_state = 22, .external_lex_state = 1},
  [424] = {.lex_state = 22, .external_lex_state = 1},
  [425] = {.lex_state = 22, .external_lex_state = 1},
  [426] = {.lex_state = 22, .external_lex_state = 1},
  [427] = {.lex_state = 22, .external_lex_state = 1},
  [428] = {.lex_state = 22, .external_lex_state = 1},
  [429] = {.lex_state = 22, .external_lex_state = 1},
  [430] = {.lex_state = 22, .external_lex_state = 1},
  [431] = {.lex_state = 22, .external_lex_state = 1},
  [432] = {.lex_state = 22, .external_lex_state = 1},
  [433] = {.lex_state = 22, .external_lex_state = 1},
  [434] = {.lex_state = 22, .external_lex_state = 1},
  [435] = {.lex_state = 22, .external_lex_state = 1},
  [436] = {.lex_state = 22, .external_lex_state = 1},
  [437] = {.lex_state = 22, .external_lex_state = 1},
  [438] = {.lex_state = 22, .external_lex_state = 1},
  [439] = {.lex_state = 22, .external_lex_state = 1},
  [440] = {.lex_state = 22, .external_lex_state = 1},
  [441] = {.lex_state = 22, .external_lex_state = 1},
  [442] = {.lex_state = 22, .external_lex_state = 1},
  [443] = {.lex_state = 22, .external_lex_state = 1},
  [444] = {.lex_state = 22, .external_lex_state = 1},
  [445] = {.lex_state = 22, .external_lex_state = 1},
  [446] = {.lex_state = 22, .external_lex_state = 1},
  [447] = {.lex_state = 22, .external_lex_state = 1},
  [448] = {.lex_state = 22, .external_lex_state = 1},
  [449] = {.lex_state = 22, .external_lex_state = 1},
  [450] = {.lex_state = 22, .external_lex_state = 1},
  [451] = {.lex_state = 22, .external_lex_state = 1},
  [452] = {.lex_state = 22, .external_lex_state = 1},
  [453] = {.lex_state = 22, .external_lex_state = 1},
  [454] = {.lex_state = 22, .external_lex_state = 1},
  [455] = {.lex_state = 22, .external_lex_state = 1},
  [456] = {.lex_state = 22, .external_lex_state = 1},
  [457] = {.lex_state = 22, .external_lex_state = 1},
  [458] = {.lex_state = 22, .external_lex_state = 1},
  [459] = {.lex_state = 22, .external_lex_state = 1},
  [460] = {.lex_state = 2},
  [461] = {.lex_state = 2},
  [462] = {.lex_state = 2},
  [463] = {.lex_state = 2, .external_lex_state = 2},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 2},
  [466] = {.lex_state = 2},
  [467] = {.lex_state = 2},
  [468] = {.lex_state = 2},
  [469] = {.lex_state = 2},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 2},
  [473] = {.lex_state = 2},
  [474] = {.lex_state = 2},
  [475] = {.lex_state = 2},
  [476] = {.lex_state = 2, .external_lex_state = 2},
  [477] = {.lex_state = 2, .external_lex_state = 2},
  [478] = {.lex_state = 2, .external_lex_state = 2},
  [479] = {.lex_state = 2, .external_lex_state = 2},
  [480] = {.lex_state = 2, .external_lex_state = 2},
  [481] = {.lex_state = 2, .external_lex_state = 2},
  [482] = {.lex_state = 2, .external_lex_state = 2},
  [483] = {.lex_state = 2, .external_lex_state = 2},
  [484] = {.lex_state = 2, .external_lex_state = 2},
  [485] = {.lex_state = 2, .external_lex_state = 2},
  [486] = {.lex_state = 2, .external_lex_state = 2},
  [487] = {.lex_state = 2, .external_lex_state = 2},
  [488] = {.lex_state = 2, .external_lex_state = 2},
  [489] = {.lex_state = 2, .external_lex_state = 2},
  [490] = {.lex_state = 2, .external_lex_state = 2},
  [491] = {.lex_state = 2, .external_lex_state = 2},
  [492] = {.lex_state = 2, .external_lex_state = 2},
  [493] = {.lex_state = 2, .external_lex_state = 2},
  [494] = {.lex_state = 2, .external_lex_state = 2},
  [495] = {.lex_state = 2, .external_lex_state = 2},
  [496] = {.lex_state = 2, .external_lex_state = 2},
  [497] = {.lex_state = 2, .external_lex_state = 2},
  [498] = {.lex_state = 2, .external_lex_state = 2},
  [499] = {.lex_state = 2, .external_lex_state = 2},
  [500] = {.lex_state = 2, .external_lex_state = 2},
  [501] = {.lex_state = 2, .external_lex_state = 2},
  [502] = {.lex_state = 2, .external_lex_state = 2},
  [503] = {.lex_state = 2, .external_lex_state = 2},
  [504] = {.lex_state = 2, .external_lex_state = 2},
  [505] = {.lex_state = 2, .external_lex_state = 2},
  [506] = {.lex_state = 2, .external_lex_state = 2},
  [507] = {.lex_state = 2, .external_lex_state = 2},
  [508] = {.lex_state = 2, .external_lex_state = 2},
  [509] = {.lex_state = 2, .external_lex_state = 2},
  [510] = {.lex_state = 2, .external_lex_state = 2},
  [511] = {.lex_state = 2, .external_lex_state = 2},
  [512] = {.lex_state = 2, .external_lex_state = 2},
  [513] = {.lex_state = 2, .external_lex_state = 2},
  [514] = {.lex_state = 2, .external_lex_state = 2},
  [515] = {.lex_state = 2, .external_lex_state = 2},
  [516] = {.lex_state = 2, .external_lex_state = 2},
  [517] = {.lex_state = 2, .external_lex_state = 2},
  [518] = {.lex_state = 2, .external_lex_state = 2},
  [519] = {.lex_state = 2, .external_lex_state = 2},
  [520] = {.lex_state = 2, .external_lex_state = 2},
  [521] = {.lex_state = 2, .external_lex_state = 2},
  [522] = {.lex_state = 2, .external_lex_state = 2},
  [523] = {.lex_state = 2, .external_lex_state = 2},
  [524] = {.lex_state = 2, .external_lex_state = 2},
  [525] = {.lex_state = 2, .external_lex_state = 2},
  [526] = {.lex_state = 2, .external_lex_state = 2},
  [527] = {.lex_state = 2, .external_lex_state = 2},
  [528] = {.lex_state = 2, .external_lex_state = 2},
  [529] = {.lex_state = 2, .external_lex_state = 2},
  [530] = {.lex_state = 2, .external_lex_state = 2},
  [531] = {.lex_state = 2, .external_lex_state = 2},
  [532] = {.lex_state = 2, .external_lex_state = 2},
  [533] = {.lex_state = 2, .external_lex_state = 2},
  [534] = {.lex_state = 2, .external_lex_state = 2},
  [535] = {.lex_state = 2, .external_lex_state = 2},
  [536] = {.lex_state = 2, .external_lex_state = 2},
  [537] = {.lex_state = 2},
  [538] = {.lex_state = 2},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
};

enum {
  ts_external_token__long_str = 0,
  ts_external_token__long_buffer = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__long_str] = sym__long_str,
  [ts_external_token__long_buffer] = sym__long_buffer,
};

static bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__long_str] = true,
    [ts_external_token__long_buffer] = true,
  },
  [2] = {
    [ts_external_token__long_str] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_splice] = ACTIONS(1),
    [anon_sym_quasiquote] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_upscope] = ACTIONS(1),
    [sym_variadic_marker] = ACTIONS(1),
    [sym_optional_marker] = ACTIONS(1),
    [sym_keys_marker] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_defn] = ACTIONS(1),
    [anon_sym_defn_DASH] = ACTIONS(1),
    [anon_sym_varfn] = ACTIONS(1),
    [anon_sym_varfn_DASH] = ACTIONS(1),
    [anon_sym_defmacro] = ACTIONS(1),
    [anon_sym_defmacro_DASH] = ACTIONS(1),
    [sym_str_literal] = ACTIONS(1),
    [sym_buffer_literal] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_nil_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_keyword] = ACTIONS(1),
    [sym__long_str] = ACTIONS(1),
    [sym__long_buffer] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(676),
    [sym__expr] = STATE(139),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [aux_sym_source_file_repeat1] = STATE(139),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [2] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(142),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_def] = ACTIONS(63),
    [anon_sym_var] = ACTIONS(65),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_fn] = ACTIONS(83),
    [anon_sym_upscope] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(97),
    [anon_sym_defn_DASH] = ACTIONS(97),
    [anon_sym_varfn] = ACTIONS(97),
    [anon_sym_varfn_DASH] = ACTIONS(97),
    [anon_sym_defmacro] = ACTIONS(97),
    [anon_sym_defmacro_DASH] = ACTIONS(97),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [3] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(115),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(115),
    [anon_sym_def] = ACTIONS(117),
    [anon_sym_var] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_fn] = ACTIONS(137),
    [anon_sym_upscope] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(141),
    [anon_sym_defn_DASH] = ACTIONS(141),
    [anon_sym_varfn] = ACTIONS(141),
    [anon_sym_varfn_DASH] = ACTIONS(141),
    [anon_sym_defmacro] = ACTIONS(141),
    [anon_sym_defmacro_DASH] = ACTIONS(141),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [4] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(114),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_def] = ACTIONS(147),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_quote] = ACTIONS(151),
    [anon_sym_splice] = ACTIONS(153),
    [anon_sym_quasiquote] = ACTIONS(155),
    [anon_sym_unquote] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_do] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_upscope] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(171),
    [anon_sym_defn_DASH] = ACTIONS(171),
    [anon_sym_varfn] = ACTIONS(171),
    [anon_sym_varfn_DASH] = ACTIONS(171),
    [anon_sym_defmacro] = ACTIONS(171),
    [anon_sym_defmacro_DASH] = ACTIONS(171),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [5] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(79),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(181),
    [anon_sym_splice] = ACTIONS(183),
    [anon_sym_quasiquote] = ACTIONS(185),
    [anon_sym_unquote] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [6] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(79),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [7] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(121),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(205),
    [anon_sym_def] = ACTIONS(207),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_quote] = ACTIONS(211),
    [anon_sym_splice] = ACTIONS(213),
    [anon_sym_quasiquote] = ACTIONS(215),
    [anon_sym_unquote] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_do] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_fn] = ACTIONS(227),
    [anon_sym_upscope] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(231),
    [anon_sym_defn_DASH] = ACTIONS(231),
    [anon_sym_varfn] = ACTIONS(231),
    [anon_sym_varfn_DASH] = ACTIONS(231),
    [anon_sym_defmacro] = ACTIONS(231),
    [anon_sym_defmacro_DASH] = ACTIONS(231),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [8] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [aux_sym_parameters_repeat1] = STATE(12),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [sym_variadic_marker] = ACTIONS(249),
    [sym_optional_marker] = ACTIONS(249),
    [sym_keys_marker] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [9] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(275),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(286),
    [anon_sym_AT_LBRACK] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_AT_LBRACE] = ACTIONS(295),
    [sym_variadic_marker] = ACTIONS(298),
    [sym_optional_marker] = ACTIONS(298),
    [sym_keys_marker] = ACTIONS(298),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(309),
    [anon_sym_PIPE] = ACTIONS(312),
    [sym_str_literal] = ACTIONS(315),
    [sym_buffer_literal] = ACTIONS(315),
    [aux_sym_number_literal_token1] = ACTIONS(318),
    [aux_sym_number_literal_token2] = ACTIONS(318),
    [aux_sym_number_literal_token3] = ACTIONS(318),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [sym_nil_literal] = ACTIONS(324),
    [sym_keyword] = ACTIONS(327),
    [sym__long_str] = ACTIONS(330),
    [sym__long_buffer] = ACTIONS(333),
  },
  [10] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(338),
    [sym_optional_marker] = ACTIONS(338),
    [sym_keys_marker] = ACTIONS(338),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [11] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [aux_sym_parameters_repeat1] = STATE(10),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(340),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(342),
    [sym_optional_marker] = ACTIONS(342),
    [sym_keys_marker] = ACTIONS(342),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [12] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(346),
    [sym_optional_marker] = ACTIONS(346),
    [sym_keys_marker] = ACTIONS(346),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [13] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(348),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [14] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(629),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [15] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(556),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(352),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [16] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(554),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [17] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(28),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [18] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [19] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(360),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [20] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(578),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [21] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(562),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [22] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(568),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [23] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(651),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [24] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(647),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [25] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(569),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [26] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(571),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [27] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(547),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [28] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(378),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [29] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [30] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(541),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [31] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(41),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [32] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(42),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [33] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(543),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [34] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(637),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [35] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(635),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(392),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [36] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(394),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(403),
    [anon_sym_AT_LBRACK] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_AT_LBRACE] = ACTIONS(412),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_PIPE] = ACTIONS(427),
    [sym_str_literal] = ACTIONS(430),
    [sym_buffer_literal] = ACTIONS(430),
    [aux_sym_number_literal_token1] = ACTIONS(433),
    [aux_sym_number_literal_token2] = ACTIONS(433),
    [aux_sym_number_literal_token3] = ACTIONS(433),
    [anon_sym_true] = ACTIONS(436),
    [anon_sym_false] = ACTIONS(436),
    [sym_nil_literal] = ACTIONS(439),
    [sym_keyword] = ACTIONS(442),
    [sym__long_str] = ACTIONS(445),
    [sym__long_buffer] = ACTIONS(448),
  },
  [37] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(599),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [38] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(630),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [39] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(602),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [40] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(53),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [41] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [42] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [43] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(608),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [44] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(628),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [45] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(614),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [46] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(626),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [47] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(615),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [48] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(617),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [49] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(19),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [50] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(51),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [51] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [52] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(481),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_LBRACK] = ACTIONS(487),
    [anon_sym_AT_LPAREN] = ACTIONS(490),
    [anon_sym_AT_LBRACK] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_AT_LBRACE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(504),
    [anon_sym_SEMI] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(516),
    [sym_str_literal] = ACTIONS(519),
    [sym_buffer_literal] = ACTIONS(519),
    [aux_sym_number_literal_token1] = ACTIONS(522),
    [aux_sym_number_literal_token2] = ACTIONS(522),
    [aux_sym_number_literal_token3] = ACTIONS(522),
    [anon_sym_true] = ACTIONS(525),
    [anon_sym_false] = ACTIONS(525),
    [sym_nil_literal] = ACTIONS(528),
    [sym_keyword] = ACTIONS(531),
    [sym__long_str] = ACTIONS(534),
    [sym__long_buffer] = ACTIONS(537),
  },
  [53] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [54] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(545),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [55] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(544),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [56] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(59),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [57] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(548),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_RBRACK] = ACTIONS(554),
    [anon_sym_AT_LPAREN] = ACTIONS(559),
    [anon_sym_AT_LBRACK] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_AT_LBRACE] = ACTIONS(568),
    [anon_sym_SQUOTE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(583),
    [sym_str_literal] = ACTIONS(586),
    [sym_buffer_literal] = ACTIONS(586),
    [aux_sym_number_literal_token1] = ACTIONS(589),
    [aux_sym_number_literal_token2] = ACTIONS(589),
    [aux_sym_number_literal_token3] = ACTIONS(589),
    [anon_sym_true] = ACTIONS(592),
    [anon_sym_false] = ACTIONS(592),
    [sym_nil_literal] = ACTIONS(595),
    [sym_keyword] = ACTIONS(598),
    [sym__long_str] = ACTIONS(601),
    [sym__long_buffer] = ACTIONS(604),
  },
  [58] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(564),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [59] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [60] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(62),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [61] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(579),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [62] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [63] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(582),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [64] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym_body] = STATE(553),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [65] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_struct_repeat1] = STATE(13),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [66] = {
    [sym__expr] = STATE(611),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [67] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [68] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(125),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [69] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(127),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [70] = {
    [sym__expr] = STATE(559),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [71] = {
    [sym__expr] = STATE(607),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(108),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [72] = {
    [sym__expr] = STATE(590),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(110),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [73] = {
    [sym__expr] = STATE(558),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(92),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [74] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(107),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [75] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(105),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [76] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [77] = {
    [sym__expr] = STATE(540),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [78] = {
    [sym__expr] = STATE(546),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [79] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [80] = {
    [sym__expr] = STATE(575),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(77),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [81] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [82] = {
    [sym__expr] = STATE(576),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(78),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [83] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [84] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [85] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [86] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [87] = {
    [sym__expr] = STATE(632),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [88] = {
    [sym__expr] = STATE(633),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [89] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(95),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [90] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(141),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [91] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(681),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [92] = {
    [sym__expr] = STATE(565),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [93] = {
    [sym__expr] = STATE(642),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(87),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [94] = {
    [sym__expr] = STATE(644),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(88),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [95] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(683),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [96] = {
    [sym__expr] = STATE(566),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [97] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(84),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [98] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(83),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [99] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(81),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [100] = {
    [sym__expr] = STATE(604),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(66),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [101] = {
    [sym__expr] = STATE(605),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(117),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [102] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [103] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [104] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [105] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [106] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(103),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [107] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [108] = {
    [sym__expr] = STATE(573),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [109] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(124),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [110] = {
    [sym__expr] = STATE(570),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [111] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [112] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [113] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [114] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [115] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [116] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(140),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [117] = {
    [sym__expr] = STATE(612),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(416),
    [sym_splice] = STATE(416),
    [sym_quasiquote] = STATE(416),
    [sym_unquote] = STATE(416),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(415),
    [sym_short_quasiquote] = STATE(415),
    [sym_short_unquote] = STATE(415),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(418),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym_metadata] = STATE(459),
    [sym__identifier] = STATE(581),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(649),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(651),
  },
  [118] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(717),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(720),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_AT_LPAREN] = ACTIONS(728),
    [anon_sym_AT_LBRACK] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(734),
    [anon_sym_AT_LBRACE] = ACTIONS(737),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_str_literal] = ACTIONS(755),
    [sym_buffer_literal] = ACTIONS(755),
    [aux_sym_number_literal_token1] = ACTIONS(758),
    [aux_sym_number_literal_token2] = ACTIONS(758),
    [aux_sym_number_literal_token3] = ACTIONS(758),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [sym_nil_literal] = ACTIONS(764),
    [sym_keyword] = ACTIONS(767),
    [sym__long_str] = ACTIONS(770),
    [sym__long_buffer] = ACTIONS(773),
  },
  [119] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(138),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [120] = {
    [sym__expr] = STATE(120),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [aux_sym_source_file_repeat1] = STATE(120),
    [ts_builtin_sym_end] = ACTIONS(778),
    [sym_symbol] = ACTIONS(780),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(786),
    [anon_sym_AT_LPAREN] = ACTIONS(789),
    [anon_sym_AT_LBRACK] = ACTIONS(792),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_AT_LBRACE] = ACTIONS(798),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_COMMA] = ACTIONS(810),
    [anon_sym_PIPE] = ACTIONS(813),
    [sym_str_literal] = ACTIONS(816),
    [sym_buffer_literal] = ACTIONS(816),
    [aux_sym_number_literal_token1] = ACTIONS(819),
    [aux_sym_number_literal_token2] = ACTIONS(819),
    [aux_sym_number_literal_token3] = ACTIONS(819),
    [anon_sym_true] = ACTIONS(822),
    [anon_sym_false] = ACTIONS(822),
    [sym_nil_literal] = ACTIONS(825),
    [sym_keyword] = ACTIONS(828),
    [sym__long_str] = ACTIONS(831),
    [sym__long_buffer] = ACTIONS(834),
  },
  [121] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [122] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(132),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [123] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [124] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [125] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [126] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(129),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [127] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [128] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(91),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [129] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [130] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(134),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [131] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(104),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [132] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_parameters_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [133] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(111),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [134] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [135] = {
    [sym__expr] = STATE(429),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_while_repeat1] = STATE(123),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [136] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(112),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [137] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(113),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [138] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [139] = {
    [sym__expr] = STATE(120),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [aux_sym_source_file_repeat1] = STATE(120),
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [140] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [141] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [142] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [aux_sym_tuple_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [143] = {
    [sym__expr] = STATE(656),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [144] = {
    [sym__expr] = STATE(643),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [145] = {
    [sym__expr] = STATE(648),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [146] = {
    [sym__expr] = STATE(598),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [147] = {
    [sym__expr] = STATE(597),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [148] = {
    [sym__expr] = STATE(653),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [149] = {
    [sym__expr] = STATE(641),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [150] = {
    [sym__expr] = STATE(594),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [151] = {
    [sym__expr] = STATE(595),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [152] = {
    [sym__expr] = STATE(654),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [153] = {
    [sym__expr] = STATE(655),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [154] = {
    [sym__expr] = STATE(638),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [155] = {
    [sym__expr] = STATE(596),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [156] = {
    [sym__expr] = STATE(631),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [157] = {
    [sym__expr] = STATE(652),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [158] = {
    [sym__expr] = STATE(567),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [159] = {
    [sym__expr] = STATE(645),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [160] = {
    [sym__expr] = STATE(563),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [161] = {
    [sym__expr] = STATE(552),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [162] = {
    [sym__expr] = STATE(613),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [163] = {
    [sym__expr] = STATE(551),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [164] = {
    [sym__expr] = STATE(542),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [165] = {
    [sym__expr] = STATE(550),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [166] = {
    [sym__expr] = STATE(549),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [167] = {
    [sym__expr] = STATE(548),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [168] = {
    [sym__expr] = STATE(583),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [169] = {
    [sym__expr] = STATE(584),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [170] = {
    [sym__expr] = STATE(585),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [171] = {
    [sym__expr] = STATE(586),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [172] = {
    [sym__expr] = STATE(587),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(945),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [173] = {
    [sym__expr] = STATE(156),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [174] = {
    [sym__expr] = STATE(646),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [175] = {
    [sym__expr] = STATE(298),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [176] = {
    [sym__expr] = STATE(299),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [177] = {
    [sym__expr] = STATE(329),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [178] = {
    [sym__expr] = STATE(301),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [179] = {
    [sym__expr] = STATE(281),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [180] = {
    [sym__expr] = STATE(271),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [181] = {
    [sym__expr] = STATE(270),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [182] = {
    [sym__expr] = STATE(269),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [183] = {
    [sym__expr] = STATE(506),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(523),
    [sym_short_splice] = STATE(523),
    [sym_short_quasiquote] = STATE(523),
    [sym_short_unquote] = STATE(523),
    [sym_short_fn] = STATE(523),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [184] = {
    [sym__expr] = STATE(300),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [185] = {
    [sym__expr] = STATE(267),
    [sym_tuple] = STATE(280),
    [sym_sqr_tuple] = STATE(280),
    [sym_array] = STATE(280),
    [sym_sqr_array] = STATE(280),
    [sym_struct] = STATE(280),
    [sym_table] = STATE(280),
    [sym_peg_set] = STATE(280),
    [sym__special_forms] = STATE(280),
    [sym_def] = STATE(235),
    [sym_var] = STATE(235),
    [sym_quote] = STATE(235),
    [sym_splice] = STATE(235),
    [sym_quasiquote] = STATE(235),
    [sym_unquote] = STATE(235),
    [sym_break] = STATE(235),
    [sym_set] = STATE(235),
    [sym_if] = STATE(235),
    [sym_do] = STATE(235),
    [sym_while] = STATE(235),
    [sym_fn] = STATE(235),
    [sym_upscope] = STATE(235),
    [sym__shorthand] = STATE(280),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(280),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(280),
    [sym_long_str_literal] = STATE(284),
    [sym_long_buffer_literal] = STATE(284),
    [sym_number_literal] = STATE(284),
    [sym_bool_literal] = STATE(284),
    [sym__identifier] = STATE(280),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [186] = {
    [sym__expr] = STATE(519),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(523),
    [sym_short_splice] = STATE(523),
    [sym_short_quasiquote] = STATE(523),
    [sym_short_unquote] = STATE(523),
    [sym_short_fn] = STATE(523),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [187] = {
    [sym__expr] = STATE(509),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(523),
    [sym_short_splice] = STATE(523),
    [sym_short_quasiquote] = STATE(523),
    [sym_short_unquote] = STATE(523),
    [sym_short_fn] = STATE(523),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [188] = {
    [sym__expr] = STATE(508),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(523),
    [sym_short_splice] = STATE(523),
    [sym_short_quasiquote] = STATE(523),
    [sym_short_unquote] = STATE(523),
    [sym_short_fn] = STATE(523),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [189] = {
    [sym__expr] = STATE(477),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(523),
    [sym_short_splice] = STATE(523),
    [sym_short_quasiquote] = STATE(523),
    [sym_short_unquote] = STATE(523),
    [sym_short_fn] = STATE(523),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [190] = {
    [sym__expr] = STATE(101),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [191] = {
    [sym__expr] = STATE(449),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [192] = {
    [sym__expr] = STATE(451),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [193] = {
    [sym__expr] = STATE(452),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [194] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [195] = {
    [sym__expr] = STATE(457),
    [sym_tuple] = STATE(434),
    [sym_sqr_tuple] = STATE(434),
    [sym_array] = STATE(434),
    [sym_sqr_array] = STATE(434),
    [sym_struct] = STATE(434),
    [sym_table] = STATE(434),
    [sym_peg_set] = STATE(434),
    [sym__special_forms] = STATE(434),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(434),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(434),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(434),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(434),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [196] = {
    [sym__expr] = STATE(100),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [197] = {
    [sym__expr] = STATE(217),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [198] = {
    [sym__expr] = STATE(70),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [199] = {
    [sym__expr] = STATE(73),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [200] = {
    [sym__expr] = STATE(220),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [201] = {
    [sym__expr] = STATE(80),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [202] = {
    [sym__expr] = STATE(82),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [203] = {
    [sym__expr] = STATE(173),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [204] = {
    [sym__expr] = STATE(93),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [205] = {
    [sym__expr] = STATE(94),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [206] = {
    [sym__expr] = STATE(216),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(445),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(441),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(450),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(985),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [207] = {
    [sym__expr] = STATE(71),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [208] = {
    [sym__expr] = STATE(72),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [209] = {
    [sym__expr] = STATE(219),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [210] = {
    [sym__expr] = STATE(86),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [211] = {
    [sym__expr] = STATE(162),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [212] = {
    [sym__expr] = STATE(422),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [213] = {
    [sym__expr] = STATE(603),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [214] = {
    [sym__expr] = STATE(106),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [215] = {
    [sym__expr] = STATE(213),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(413),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(414),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(409),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(987),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [216] = {
    [sym__expr] = STATE(616),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [217] = {
    [sym__expr] = STATE(158),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [218] = {
    [sym__expr] = STATE(557),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [219] = {
    [sym__expr] = STATE(160),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [220] = {
    [sym__expr] = STATE(164),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [221] = {
    [sym__expr] = STATE(218),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(369),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(368),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(370),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(989),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [222] = {
    [sym__expr] = STATE(130),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [223] = {
    [sym__expr] = STATE(225),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(404),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(403),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(405),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(991),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [224] = {
    [sym__expr] = STATE(89),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [225] = {
    [sym__expr] = STATE(577),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [226] = {
    [sym__expr] = STATE(174),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(454),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(455),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(453),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(993),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [227] = {
    [sym__expr] = STATE(609),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [228] = {
    [sym__expr] = STATE(610),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [229] = {
    [sym__expr] = STATE(618),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [230] = {
    [sym__expr] = STATE(211),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [231] = {
    [sym__expr] = STATE(619),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [232] = {
    [sym__expr] = STATE(620),
    [sym_tuple] = STATE(581),
    [sym_sqr_tuple] = STATE(581),
    [sym_array] = STATE(581),
    [sym_sqr_array] = STATE(581),
    [sym_struct] = STATE(581),
    [sym_table] = STATE(581),
    [sym_peg_set] = STATE(581),
    [sym__special_forms] = STATE(581),
    [sym_def] = STATE(588),
    [sym_var] = STATE(588),
    [sym_quote] = STATE(588),
    [sym_splice] = STATE(588),
    [sym_quasiquote] = STATE(588),
    [sym_unquote] = STATE(588),
    [sym_break] = STATE(588),
    [sym_set] = STATE(588),
    [sym_if] = STATE(588),
    [sym_do] = STATE(588),
    [sym_while] = STATE(588),
    [sym_fn] = STATE(588),
    [sym_upscope] = STATE(588),
    [sym__shorthand] = STATE(581),
    [sym_short_quote] = STATE(589),
    [sym_short_splice] = STATE(589),
    [sym_short_quasiquote] = STATE(589),
    [sym_short_unquote] = STATE(589),
    [sym_short_fn] = STATE(589),
    [sym__specials] = STATE(581),
    [sym_extra_defs] = STATE(591),
    [sym__literals] = STATE(581),
    [sym_long_str_literal] = STATE(561),
    [sym_long_buffer_literal] = STATE(561),
    [sym_number_literal] = STATE(561),
    [sym_bool_literal] = STATE(561),
    [sym__identifier] = STATE(581),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_AT_LBRACE] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(637),
    [sym_str_literal] = ACTIONS(641),
    [sym_buffer_literal] = ACTIONS(641),
    [aux_sym_number_literal_token1] = ACTIONS(643),
    [aux_sym_number_literal_token2] = ACTIONS(643),
    [aux_sym_number_literal_token3] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(645),
    [sym_nil_literal] = ACTIONS(647),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(651),
  },
  [233] = {
    [sym__expr] = STATE(135),
    [sym_tuple] = STATE(346),
    [sym_sqr_tuple] = STATE(346),
    [sym_array] = STATE(346),
    [sym_sqr_array] = STATE(346),
    [sym_struct] = STATE(346),
    [sym_table] = STATE(346),
    [sym_peg_set] = STATE(346),
    [sym__special_forms] = STATE(346),
    [sym_def] = STATE(334),
    [sym_var] = STATE(334),
    [sym_quote] = STATE(334),
    [sym_splice] = STATE(334),
    [sym_quasiquote] = STATE(334),
    [sym_unquote] = STATE(334),
    [sym_break] = STATE(334),
    [sym_set] = STATE(334),
    [sym_if] = STATE(334),
    [sym_do] = STATE(334),
    [sym_while] = STATE(334),
    [sym_fn] = STATE(334),
    [sym_upscope] = STATE(334),
    [sym__shorthand] = STATE(346),
    [sym_short_quote] = STATE(318),
    [sym_short_splice] = STATE(318),
    [sym_short_quasiquote] = STATE(318),
    [sym_short_unquote] = STATE(318),
    [sym_short_fn] = STATE(318),
    [sym__specials] = STATE(346),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(346),
    [sym_long_str_literal] = STATE(336),
    [sym_long_buffer_literal] = STATE(336),
    [sym_number_literal] = STATE(336),
    [sym_bool_literal] = STATE(336),
    [sym__identifier] = STATE(346),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(997), 1,
      anon_sym_LPAREN,
    ACTIONS(1002), 1,
      anon_sym_SQUOTE,
    ACTIONS(1005), 1,
      anon_sym_SEMI,
    ACTIONS(1008), 1,
      anon_sym_TILDE,
    ACTIONS(1011), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    STATE(234), 1,
      aux_sym_def_repeat1,
    STATE(459), 1,
      sym_metadata,
    ACTIONS(1014), 2,
      sym_str_literal,
      sym_keyword,
    ACTIONS(995), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1000), 8,
      sym__long_buffer,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    STATE(458), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [62] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1020), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [98] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1024), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1026), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [134] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1030), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [170] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1032), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1034), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [206] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1036), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1038), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [242] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1040), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1042), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [278] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1044), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1046), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [314] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1048), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1050), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [350] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [386] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [458] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [494] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1070), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [530] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [566] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [602] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [638] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [674] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [710] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [746] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [782] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [818] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [854] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1110), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [890] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [926] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [962] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [998] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1034] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1070] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1142] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1178] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1214] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1250] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1286] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1322] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1358] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1394] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1430] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1466] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1502] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1538] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1574] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1610] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1646] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1682] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1718] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1754] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1790] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1826] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1862] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1898] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1934] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2006] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2042] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2078] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2114] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2150] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2186] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2222] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2256] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2324] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2358] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2392] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2426] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2460] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2494] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2528] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2562] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2596] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2630] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2664] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2698] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2732] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2766] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2800] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2834] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2868] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2902] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2936] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3004] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3038] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3072] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3140] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3174] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3208] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1070), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3242] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3276] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3310] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3344] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3378] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3412] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3446] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3480] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3514] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3548] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3582] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3616] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3650] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3684] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3718] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3752] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1048), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1050), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3786] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1044), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1046), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3820] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3854] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1024), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1026), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3888] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3922] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3956] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3990] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4024] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4058] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4092] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1030), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4126] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1032), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1034), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4160] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1036), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1038), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4194] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1040), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1042), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4228] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(361), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(30), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4287] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(356), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(44), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4346] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(46), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4405] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(358), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(54), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4464] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(27), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4523] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(363), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(25), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4582] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(365), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(47), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4641] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(16), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4700] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1270), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4733] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(26), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4792] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1110), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4825] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    ACTIONS(1264), 1,
      sym_str_literal,
    ACTIONS(1266), 1,
      sym_keyword,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(510), 1,
      sym_long_str_literal,
    STATE(522), 1,
      sym_metadata,
    STATE(48), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(391), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4884] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1274), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4916] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4948] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4982] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 1,
      anon_sym_RPAREN,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5016] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5050] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1044), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1046), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5082] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1040), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1042), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5114] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1036), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1038), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5146] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1032), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1034), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5178] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1030), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5210] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1278), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1280), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5242] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1282), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1284), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5274] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5306] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5338] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1024), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1026), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5370] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1286), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1288), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5402] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5434] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 1,
      sym_symbol,
    ACTIONS(1140), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1142), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1292), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5470] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5502] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1294), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1296), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5534] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5566] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5598] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5630] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5662] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1070), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5694] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 1,
      sym_symbol,
    ACTIONS(1300), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1298), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1292), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5730] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5762] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5794] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1302), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1304), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5826] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1306), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1308), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5858] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5890] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5922] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5954] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5986] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6018] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6050] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6082] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6116] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6150] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6184] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6216] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6248] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1048), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1050), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6280] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6314] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1314), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1316), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6346] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6378] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6410] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6444] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6478] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1292), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6512] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1022), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1292), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6546] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1142), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1292), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6580] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1292), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6614] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6646] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6678] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6710] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1318), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1320), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6742] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6774] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6806] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6838] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6870] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6902] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1322), 1,
      sym_symbol,
    ACTIONS(1300), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1324), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_keyword,
    ACTIONS(1298), 10,
      sym__long_str,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
  [6938] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1326), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1328), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7002] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7034] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7066] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7098] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7130] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7162] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7194] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7226] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7258] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7322] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7356] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7388] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7420] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7452] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7486] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7518] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1332), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1334), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7550] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7582] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7614] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7648] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7680] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7712] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7746] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    ACTIONS(1020), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1022), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7780] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7814] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7846] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7878] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1292), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1338), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1340), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7940] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(470), 1,
      sym__name,
    STATE(34), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(428), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [7987] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(469), 1,
      sym__name,
    STATE(61), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(428), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8034] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(467), 1,
      sym__name,
    STATE(21), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(428), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8081] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(995), 1,
      sym_symbol,
    ACTIONS(1000), 1,
      anon_sym_LBRACK,
    ACTIONS(1342), 1,
      anon_sym_LPAREN,
    ACTIONS(1345), 1,
      anon_sym_SQUOTE,
    ACTIONS(1348), 1,
      anon_sym_SEMI,
    ACTIONS(1351), 1,
      anon_sym_TILDE,
    ACTIONS(1354), 1,
      anon_sym_COMMA,
    ACTIONS(1360), 1,
      sym__long_str,
    STATE(463), 1,
      aux_sym_def_repeat1,
    STATE(522), 1,
      sym_metadata,
    ACTIONS(1357), 2,
      sym_str_literal,
      sym_keyword,
    STATE(510), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [8130] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(466), 1,
      sym__name,
    STATE(43), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(428), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8177] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(468), 1,
      sym__name,
    STATE(58), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(428), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8224] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(45), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8266] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(22), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8308] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(55), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8350] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(33), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8392] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1260), 1,
      anon_sym_LPAREN,
    ACTIONS(1262), 1,
      anon_sym_LBRACK,
    STATE(14), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8434] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    STATE(354), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8471] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    STATE(355), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8508] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    STATE(360), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8545] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    STATE(359), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8582] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    STATE(357), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8619] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 1,
      sym_symbol,
    ACTIONS(1106), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8637] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 1,
      sym_symbol,
    ACTIONS(1158), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8655] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 1,
      sym_symbol,
    ACTIONS(1230), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8673] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1040), 1,
      sym_symbol,
    ACTIONS(1042), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8691] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 1,
      sym_symbol,
    ACTIONS(1234), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8709] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1044), 1,
      sym_symbol,
    ACTIONS(1046), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8727] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1048), 1,
      sym_symbol,
    ACTIONS(1050), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8745] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 1,
      sym_symbol,
    ACTIONS(1054), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8763] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 1,
      sym_symbol,
    ACTIONS(1058), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8781] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 1,
      sym_symbol,
    ACTIONS(1062), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8799] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 1,
      sym_symbol,
    ACTIONS(1066), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8817] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 1,
      sym_symbol,
    ACTIONS(1070), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8835] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 1,
      sym_symbol,
    ACTIONS(1074), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8853] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 1,
      sym_symbol,
    ACTIONS(1078), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8871] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 1,
      sym_symbol,
    ACTIONS(1082), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8889] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 1,
      sym_symbol,
    ACTIONS(1086), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8907] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 1,
      sym_symbol,
    ACTIONS(1090), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8925] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 1,
      sym_symbol,
    ACTIONS(1146), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8943] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1032), 1,
      sym_symbol,
    ACTIONS(1034), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8961] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 1,
      sym_symbol,
    ACTIONS(1094), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8979] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 1,
      sym_symbol,
    ACTIONS(1098), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8997] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 1,
      sym_symbol,
    ACTIONS(1102), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9015] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_symbol,
    ACTIONS(1030), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9033] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 1,
      sym_symbol,
    ACTIONS(1118), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9051] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 1,
      sym_symbol,
    ACTIONS(1122), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9069] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 1,
      sym_symbol,
    ACTIONS(1126), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9087] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 1,
      sym_symbol,
    ACTIONS(1130), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9105] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 1,
      sym_symbol,
    ACTIONS(1134), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9123] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 1,
      sym_symbol,
    ACTIONS(1138), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9141] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 1,
      sym_symbol,
    ACTIONS(1142), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9159] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 1,
      sym_symbol,
    ACTIONS(1150), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9177] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1036), 1,
      sym_symbol,
    ACTIONS(1038), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9195] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 1,
      sym_symbol,
    ACTIONS(1162), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 1,
      sym_symbol,
    ACTIONS(1166), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9231] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 1,
      sym_symbol,
    ACTIONS(1292), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9249] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 1,
      sym_symbol,
    ACTIONS(1114), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9267] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 1,
      sym_symbol,
    ACTIONS(1170), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9285] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 1,
      sym_symbol,
    ACTIONS(1174), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9303] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 1,
      sym_symbol,
    ACTIONS(1178), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9321] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 1,
      sym_symbol,
    ACTIONS(1182), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9339] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 1,
      sym_symbol,
    ACTIONS(1186), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9357] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 1,
      sym_symbol,
    ACTIONS(1190), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9375] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_symbol,
    ACTIONS(1194), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9393] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 1,
      sym_symbol,
    ACTIONS(1206), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9411] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 1,
      sym_symbol,
    ACTIONS(1154), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9429] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1024), 1,
      sym_symbol,
    ACTIONS(1026), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9447] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1338), 1,
      sym_symbol,
    ACTIONS(1340), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9465] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 1,
      sym_symbol,
    ACTIONS(1198), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9483] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1020), 1,
      sym_symbol,
    ACTIONS(1022), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9501] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 1,
      sym_symbol,
    ACTIONS(1202), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9519] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 1,
      sym_symbol,
    ACTIONS(1210), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9537] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 1,
      sym_symbol,
    ACTIONS(1214), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9555] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 1,
      sym_symbol,
    ACTIONS(1218), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9573] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 1,
      sym_symbol,
    ACTIONS(1222), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9591] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 1,
      sym_symbol,
    ACTIONS(1226), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9609] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 1,
      sym_symbol,
    ACTIONS(1258), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9627] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 1,
      sym_symbol,
    ACTIONS(1254), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9645] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 1,
      sym_symbol,
    ACTIONS(1250), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9663] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 1,
      sym_symbol,
    ACTIONS(1246), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9681] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 1,
      sym_symbol,
    ACTIONS(1242), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9699] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 1,
      sym_symbol,
    ACTIONS(1238), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9717] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 1,
      anon_sym_quote,
    ACTIONS(1367), 1,
      anon_sym_splice,
    ACTIONS(1369), 1,
      anon_sym_quasiquote,
    ACTIONS(1371), 1,
      anon_sym_unquote,
  [9733] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1373), 1,
      anon_sym_quote,
    ACTIONS(1375), 1,
      anon_sym_splice,
    ACTIONS(1377), 1,
      anon_sym_quasiquote,
    ACTIONS(1379), 1,
      anon_sym_unquote,
  [9749] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1226), 1,
      anon_sym_RPAREN,
  [9756] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
  [9763] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1383), 1,
      anon_sym_RPAREN,
  [9770] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1385), 1,
      anon_sym_RPAREN,
  [9777] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
  [9784] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 1,
      anon_sym_RPAREN,
  [9791] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1391), 1,
      anon_sym_RPAREN,
  [9798] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1393), 1,
      anon_sym_RPAREN,
  [9805] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1395), 1,
      anon_sym_RPAREN,
  [9812] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1397), 1,
      anon_sym_RPAREN,
  [9819] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1399), 1,
      anon_sym_RPAREN,
  [9826] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1401), 1,
      anon_sym_RPAREN,
  [9833] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1403), 1,
      anon_sym_RPAREN,
  [9840] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1405), 1,
      anon_sym_RPAREN,
  [9847] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1407), 1,
      anon_sym_RPAREN,
  [9854] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
  [9861] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1222), 1,
      anon_sym_RPAREN,
  [9868] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1411), 1,
      anon_sym_RPAREN,
  [9875] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1413), 1,
      anon_sym_RPAREN,
  [9882] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
  [9889] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
  [9896] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1042), 1,
      anon_sym_RPAREN,
  [9903] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
  [9910] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1419), 1,
      anon_sym_RPAREN,
  [9917] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
  [9924] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1423), 1,
      anon_sym_RPAREN,
  [9931] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1425), 1,
      anon_sym_RPAREN,
  [9938] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1427), 1,
      anon_sym_RPAREN,
  [9945] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
  [9952] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1431), 1,
      anon_sym_RPAREN,
  [9959] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1433), 1,
      anon_sym_RPAREN,
  [9966] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
  [9973] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
  [9980] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
  [9987] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
  [9994] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
  [10001] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [10008] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
  [10015] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [10022] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
  [10029] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
  [10036] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1142), 1,
      anon_sym_RPAREN,
  [10043] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
  [10050] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
  [10057] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
  [10064] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
  [10071] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      anon_sym_RPAREN,
  [10078] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1459), 1,
      anon_sym_RPAREN,
  [10085] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1461), 1,
      anon_sym_RPAREN,
  [10092] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1022), 1,
      anon_sym_RPAREN,
  [10099] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
  [10106] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
  [10113] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
  [10120] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
  [10127] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
  [10134] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
  [10141] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
  [10148] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
  [10155] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
  [10162] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1473), 1,
      anon_sym_RPAREN,
  [10169] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
  [10176] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
  [10183] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1174), 1,
      anon_sym_RPAREN,
  [10190] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
  [10197] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
  [10204] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
  [10211] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
  [10218] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
  [10225] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
  [10232] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
  [10239] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
  [10246] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
  [10253] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1489), 1,
      anon_sym_RPAREN,
  [10260] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
  [10267] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
  [10274] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1495), 1,
      anon_sym_RPAREN,
  [10281] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1497), 1,
      anon_sym_RPAREN,
  [10288] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1499), 1,
      anon_sym_RPAREN,
  [10295] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1501), 1,
      anon_sym_RPAREN,
  [10302] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
  [10309] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
  [10316] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1150), 1,
      anon_sym_RPAREN,
  [10323] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1230), 1,
      anon_sym_RPAREN,
  [10330] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1234), 1,
      anon_sym_RPAREN,
  [10337] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
  [10344] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1242), 1,
      anon_sym_RPAREN,
  [10351] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1138), 1,
      anon_sym_RPAREN,
  [10358] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
  [10365] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
  [10372] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1505), 1,
      anon_sym_RPAREN,
  [10379] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
  [10386] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
  [10393] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
  [10400] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
  [10407] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [10414] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1130), 1,
      anon_sym_RPAREN,
  [10421] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
  [10428] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1126), 1,
      anon_sym_RPAREN,
  [10435] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
  [10442] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [10449] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1122), 1,
      anon_sym_RPAREN,
  [10456] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
  [10463] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1523), 1,
      anon_sym_RPAREN,
  [10470] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
  [10477] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
  [10484] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1529), 1,
      anon_sym_RPAREN,
  [10491] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
  [10498] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1533), 1,
      anon_sym_RPAREN,
  [10505] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
  [10512] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1537), 1,
      anon_sym_RPAREN,
  [10519] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1106), 1,
      anon_sym_RPAREN,
  [10526] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
  [10533] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
  [10540] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
  [10547] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1543), 1,
      anon_sym_RPAREN,
  [10554] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
  [10561] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
  [10568] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
  [10575] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1098), 1,
      anon_sym_RPAREN,
  [10582] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1094), 1,
      anon_sym_RPAREN,
  [10589] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1246), 1,
      anon_sym_RPAREN,
  [10596] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1250), 1,
      anon_sym_RPAREN,
  [10603] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1254), 1,
      anon_sym_RPAREN,
  [10610] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1258), 1,
      anon_sym_RPAREN,
  [10617] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
  [10624] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1086), 1,
      anon_sym_RPAREN,
  [10631] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
  [10638] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
  [10645] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
  [10652] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
  [10659] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
  [10666] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
  [10673] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
  [10680] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
  [10687] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
  [10694] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1046), 1,
      anon_sym_RPAREN,
  [10701] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1186), 1,
      anon_sym_RPAREN,
  [10708] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1551), 1,
      ts_builtin_sym_end,
  [10715] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1038), 1,
      anon_sym_RPAREN,
  [10722] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
  [10729] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
  [10736] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1114), 1,
      anon_sym_RPAREN,
  [10743] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
  [10750] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1026), 1,
      anon_sym_RPAREN,
  [10757] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1146), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(234)] = 0,
  [SMALL_STATE(235)] = 62,
  [SMALL_STATE(236)] = 98,
  [SMALL_STATE(237)] = 134,
  [SMALL_STATE(238)] = 170,
  [SMALL_STATE(239)] = 206,
  [SMALL_STATE(240)] = 242,
  [SMALL_STATE(241)] = 278,
  [SMALL_STATE(242)] = 314,
  [SMALL_STATE(243)] = 350,
  [SMALL_STATE(244)] = 386,
  [SMALL_STATE(245)] = 422,
  [SMALL_STATE(246)] = 458,
  [SMALL_STATE(247)] = 494,
  [SMALL_STATE(248)] = 530,
  [SMALL_STATE(249)] = 566,
  [SMALL_STATE(250)] = 602,
  [SMALL_STATE(251)] = 638,
  [SMALL_STATE(252)] = 674,
  [SMALL_STATE(253)] = 710,
  [SMALL_STATE(254)] = 746,
  [SMALL_STATE(255)] = 782,
  [SMALL_STATE(256)] = 818,
  [SMALL_STATE(257)] = 854,
  [SMALL_STATE(258)] = 890,
  [SMALL_STATE(259)] = 926,
  [SMALL_STATE(260)] = 962,
  [SMALL_STATE(261)] = 998,
  [SMALL_STATE(262)] = 1034,
  [SMALL_STATE(263)] = 1070,
  [SMALL_STATE(264)] = 1106,
  [SMALL_STATE(265)] = 1142,
  [SMALL_STATE(266)] = 1178,
  [SMALL_STATE(267)] = 1214,
  [SMALL_STATE(268)] = 1250,
  [SMALL_STATE(269)] = 1286,
  [SMALL_STATE(270)] = 1322,
  [SMALL_STATE(271)] = 1358,
  [SMALL_STATE(272)] = 1394,
  [SMALL_STATE(273)] = 1430,
  [SMALL_STATE(274)] = 1466,
  [SMALL_STATE(275)] = 1502,
  [SMALL_STATE(276)] = 1538,
  [SMALL_STATE(277)] = 1574,
  [SMALL_STATE(278)] = 1610,
  [SMALL_STATE(279)] = 1646,
  [SMALL_STATE(280)] = 1682,
  [SMALL_STATE(281)] = 1718,
  [SMALL_STATE(282)] = 1754,
  [SMALL_STATE(283)] = 1790,
  [SMALL_STATE(284)] = 1826,
  [SMALL_STATE(285)] = 1862,
  [SMALL_STATE(286)] = 1898,
  [SMALL_STATE(287)] = 1934,
  [SMALL_STATE(288)] = 1970,
  [SMALL_STATE(289)] = 2006,
  [SMALL_STATE(290)] = 2042,
  [SMALL_STATE(291)] = 2078,
  [SMALL_STATE(292)] = 2114,
  [SMALL_STATE(293)] = 2150,
  [SMALL_STATE(294)] = 2186,
  [SMALL_STATE(295)] = 2222,
  [SMALL_STATE(296)] = 2256,
  [SMALL_STATE(297)] = 2290,
  [SMALL_STATE(298)] = 2324,
  [SMALL_STATE(299)] = 2358,
  [SMALL_STATE(300)] = 2392,
  [SMALL_STATE(301)] = 2426,
  [SMALL_STATE(302)] = 2460,
  [SMALL_STATE(303)] = 2494,
  [SMALL_STATE(304)] = 2528,
  [SMALL_STATE(305)] = 2562,
  [SMALL_STATE(306)] = 2596,
  [SMALL_STATE(307)] = 2630,
  [SMALL_STATE(308)] = 2664,
  [SMALL_STATE(309)] = 2698,
  [SMALL_STATE(310)] = 2732,
  [SMALL_STATE(311)] = 2766,
  [SMALL_STATE(312)] = 2800,
  [SMALL_STATE(313)] = 2834,
  [SMALL_STATE(314)] = 2868,
  [SMALL_STATE(315)] = 2902,
  [SMALL_STATE(316)] = 2936,
  [SMALL_STATE(317)] = 2970,
  [SMALL_STATE(318)] = 3004,
  [SMALL_STATE(319)] = 3038,
  [SMALL_STATE(320)] = 3072,
  [SMALL_STATE(321)] = 3106,
  [SMALL_STATE(322)] = 3140,
  [SMALL_STATE(323)] = 3174,
  [SMALL_STATE(324)] = 3208,
  [SMALL_STATE(325)] = 3242,
  [SMALL_STATE(326)] = 3276,
  [SMALL_STATE(327)] = 3310,
  [SMALL_STATE(328)] = 3344,
  [SMALL_STATE(329)] = 3378,
  [SMALL_STATE(330)] = 3412,
  [SMALL_STATE(331)] = 3446,
  [SMALL_STATE(332)] = 3480,
  [SMALL_STATE(333)] = 3514,
  [SMALL_STATE(334)] = 3548,
  [SMALL_STATE(335)] = 3582,
  [SMALL_STATE(336)] = 3616,
  [SMALL_STATE(337)] = 3650,
  [SMALL_STATE(338)] = 3684,
  [SMALL_STATE(339)] = 3718,
  [SMALL_STATE(340)] = 3752,
  [SMALL_STATE(341)] = 3786,
  [SMALL_STATE(342)] = 3820,
  [SMALL_STATE(343)] = 3854,
  [SMALL_STATE(344)] = 3888,
  [SMALL_STATE(345)] = 3922,
  [SMALL_STATE(346)] = 3956,
  [SMALL_STATE(347)] = 3990,
  [SMALL_STATE(348)] = 4024,
  [SMALL_STATE(349)] = 4058,
  [SMALL_STATE(350)] = 4092,
  [SMALL_STATE(351)] = 4126,
  [SMALL_STATE(352)] = 4160,
  [SMALL_STATE(353)] = 4194,
  [SMALL_STATE(354)] = 4228,
  [SMALL_STATE(355)] = 4287,
  [SMALL_STATE(356)] = 4346,
  [SMALL_STATE(357)] = 4405,
  [SMALL_STATE(358)] = 4464,
  [SMALL_STATE(359)] = 4523,
  [SMALL_STATE(360)] = 4582,
  [SMALL_STATE(361)] = 4641,
  [SMALL_STATE(362)] = 4700,
  [SMALL_STATE(363)] = 4733,
  [SMALL_STATE(364)] = 4792,
  [SMALL_STATE(365)] = 4825,
  [SMALL_STATE(366)] = 4884,
  [SMALL_STATE(367)] = 4916,
  [SMALL_STATE(368)] = 4948,
  [SMALL_STATE(369)] = 4982,
  [SMALL_STATE(370)] = 5016,
  [SMALL_STATE(371)] = 5050,
  [SMALL_STATE(372)] = 5082,
  [SMALL_STATE(373)] = 5114,
  [SMALL_STATE(374)] = 5146,
  [SMALL_STATE(375)] = 5178,
  [SMALL_STATE(376)] = 5210,
  [SMALL_STATE(377)] = 5242,
  [SMALL_STATE(378)] = 5274,
  [SMALL_STATE(379)] = 5306,
  [SMALL_STATE(380)] = 5338,
  [SMALL_STATE(381)] = 5370,
  [SMALL_STATE(382)] = 5402,
  [SMALL_STATE(383)] = 5434,
  [SMALL_STATE(384)] = 5470,
  [SMALL_STATE(385)] = 5502,
  [SMALL_STATE(386)] = 5534,
  [SMALL_STATE(387)] = 5566,
  [SMALL_STATE(388)] = 5598,
  [SMALL_STATE(389)] = 5630,
  [SMALL_STATE(390)] = 5662,
  [SMALL_STATE(391)] = 5694,
  [SMALL_STATE(392)] = 5730,
  [SMALL_STATE(393)] = 5762,
  [SMALL_STATE(394)] = 5794,
  [SMALL_STATE(395)] = 5826,
  [SMALL_STATE(396)] = 5858,
  [SMALL_STATE(397)] = 5890,
  [SMALL_STATE(398)] = 5922,
  [SMALL_STATE(399)] = 5954,
  [SMALL_STATE(400)] = 5986,
  [SMALL_STATE(401)] = 6018,
  [SMALL_STATE(402)] = 6050,
  [SMALL_STATE(403)] = 6082,
  [SMALL_STATE(404)] = 6116,
  [SMALL_STATE(405)] = 6150,
  [SMALL_STATE(406)] = 6184,
  [SMALL_STATE(407)] = 6216,
  [SMALL_STATE(408)] = 6248,
  [SMALL_STATE(409)] = 6280,
  [SMALL_STATE(410)] = 6314,
  [SMALL_STATE(411)] = 6346,
  [SMALL_STATE(412)] = 6378,
  [SMALL_STATE(413)] = 6410,
  [SMALL_STATE(414)] = 6444,
  [SMALL_STATE(415)] = 6478,
  [SMALL_STATE(416)] = 6512,
  [SMALL_STATE(417)] = 6546,
  [SMALL_STATE(418)] = 6580,
  [SMALL_STATE(419)] = 6614,
  [SMALL_STATE(420)] = 6646,
  [SMALL_STATE(421)] = 6678,
  [SMALL_STATE(422)] = 6710,
  [SMALL_STATE(423)] = 6742,
  [SMALL_STATE(424)] = 6774,
  [SMALL_STATE(425)] = 6806,
  [SMALL_STATE(426)] = 6838,
  [SMALL_STATE(427)] = 6870,
  [SMALL_STATE(428)] = 6902,
  [SMALL_STATE(429)] = 6938,
  [SMALL_STATE(430)] = 6970,
  [SMALL_STATE(431)] = 7002,
  [SMALL_STATE(432)] = 7034,
  [SMALL_STATE(433)] = 7066,
  [SMALL_STATE(434)] = 7098,
  [SMALL_STATE(435)] = 7130,
  [SMALL_STATE(436)] = 7162,
  [SMALL_STATE(437)] = 7194,
  [SMALL_STATE(438)] = 7226,
  [SMALL_STATE(439)] = 7258,
  [SMALL_STATE(440)] = 7290,
  [SMALL_STATE(441)] = 7322,
  [SMALL_STATE(442)] = 7356,
  [SMALL_STATE(443)] = 7388,
  [SMALL_STATE(444)] = 7420,
  [SMALL_STATE(445)] = 7452,
  [SMALL_STATE(446)] = 7486,
  [SMALL_STATE(447)] = 7518,
  [SMALL_STATE(448)] = 7550,
  [SMALL_STATE(449)] = 7582,
  [SMALL_STATE(450)] = 7614,
  [SMALL_STATE(451)] = 7648,
  [SMALL_STATE(452)] = 7680,
  [SMALL_STATE(453)] = 7712,
  [SMALL_STATE(454)] = 7746,
  [SMALL_STATE(455)] = 7780,
  [SMALL_STATE(456)] = 7814,
  [SMALL_STATE(457)] = 7846,
  [SMALL_STATE(458)] = 7878,
  [SMALL_STATE(459)] = 7909,
  [SMALL_STATE(460)] = 7940,
  [SMALL_STATE(461)] = 7987,
  [SMALL_STATE(462)] = 8034,
  [SMALL_STATE(463)] = 8081,
  [SMALL_STATE(464)] = 8130,
  [SMALL_STATE(465)] = 8177,
  [SMALL_STATE(466)] = 8224,
  [SMALL_STATE(467)] = 8266,
  [SMALL_STATE(468)] = 8308,
  [SMALL_STATE(469)] = 8350,
  [SMALL_STATE(470)] = 8392,
  [SMALL_STATE(471)] = 8434,
  [SMALL_STATE(472)] = 8471,
  [SMALL_STATE(473)] = 8508,
  [SMALL_STATE(474)] = 8545,
  [SMALL_STATE(475)] = 8582,
  [SMALL_STATE(476)] = 8619,
  [SMALL_STATE(477)] = 8637,
  [SMALL_STATE(478)] = 8655,
  [SMALL_STATE(479)] = 8673,
  [SMALL_STATE(480)] = 8691,
  [SMALL_STATE(481)] = 8709,
  [SMALL_STATE(482)] = 8727,
  [SMALL_STATE(483)] = 8745,
  [SMALL_STATE(484)] = 8763,
  [SMALL_STATE(485)] = 8781,
  [SMALL_STATE(486)] = 8799,
  [SMALL_STATE(487)] = 8817,
  [SMALL_STATE(488)] = 8835,
  [SMALL_STATE(489)] = 8853,
  [SMALL_STATE(490)] = 8871,
  [SMALL_STATE(491)] = 8889,
  [SMALL_STATE(492)] = 8907,
  [SMALL_STATE(493)] = 8925,
  [SMALL_STATE(494)] = 8943,
  [SMALL_STATE(495)] = 8961,
  [SMALL_STATE(496)] = 8979,
  [SMALL_STATE(497)] = 8997,
  [SMALL_STATE(498)] = 9015,
  [SMALL_STATE(499)] = 9033,
  [SMALL_STATE(500)] = 9051,
  [SMALL_STATE(501)] = 9069,
  [SMALL_STATE(502)] = 9087,
  [SMALL_STATE(503)] = 9105,
  [SMALL_STATE(504)] = 9123,
  [SMALL_STATE(505)] = 9141,
  [SMALL_STATE(506)] = 9159,
  [SMALL_STATE(507)] = 9177,
  [SMALL_STATE(508)] = 9195,
  [SMALL_STATE(509)] = 9213,
  [SMALL_STATE(510)] = 9231,
  [SMALL_STATE(511)] = 9249,
  [SMALL_STATE(512)] = 9267,
  [SMALL_STATE(513)] = 9285,
  [SMALL_STATE(514)] = 9303,
  [SMALL_STATE(515)] = 9321,
  [SMALL_STATE(516)] = 9339,
  [SMALL_STATE(517)] = 9357,
  [SMALL_STATE(518)] = 9375,
  [SMALL_STATE(519)] = 9393,
  [SMALL_STATE(520)] = 9411,
  [SMALL_STATE(521)] = 9429,
  [SMALL_STATE(522)] = 9447,
  [SMALL_STATE(523)] = 9465,
  [SMALL_STATE(524)] = 9483,
  [SMALL_STATE(525)] = 9501,
  [SMALL_STATE(526)] = 9519,
  [SMALL_STATE(527)] = 9537,
  [SMALL_STATE(528)] = 9555,
  [SMALL_STATE(529)] = 9573,
  [SMALL_STATE(530)] = 9591,
  [SMALL_STATE(531)] = 9609,
  [SMALL_STATE(532)] = 9627,
  [SMALL_STATE(533)] = 9645,
  [SMALL_STATE(534)] = 9663,
  [SMALL_STATE(535)] = 9681,
  [SMALL_STATE(536)] = 9699,
  [SMALL_STATE(537)] = 9717,
  [SMALL_STATE(538)] = 9733,
  [SMALL_STATE(539)] = 9749,
  [SMALL_STATE(540)] = 9756,
  [SMALL_STATE(541)] = 9763,
  [SMALL_STATE(542)] = 9770,
  [SMALL_STATE(543)] = 9777,
  [SMALL_STATE(544)] = 9784,
  [SMALL_STATE(545)] = 9791,
  [SMALL_STATE(546)] = 9798,
  [SMALL_STATE(547)] = 9805,
  [SMALL_STATE(548)] = 9812,
  [SMALL_STATE(549)] = 9819,
  [SMALL_STATE(550)] = 9826,
  [SMALL_STATE(551)] = 9833,
  [SMALL_STATE(552)] = 9840,
  [SMALL_STATE(553)] = 9847,
  [SMALL_STATE(554)] = 9854,
  [SMALL_STATE(555)] = 9861,
  [SMALL_STATE(556)] = 9868,
  [SMALL_STATE(557)] = 9875,
  [SMALL_STATE(558)] = 9882,
  [SMALL_STATE(559)] = 9889,
  [SMALL_STATE(560)] = 9896,
  [SMALL_STATE(561)] = 9903,
  [SMALL_STATE(562)] = 9910,
  [SMALL_STATE(563)] = 9917,
  [SMALL_STATE(564)] = 9924,
  [SMALL_STATE(565)] = 9931,
  [SMALL_STATE(566)] = 9938,
  [SMALL_STATE(567)] = 9945,
  [SMALL_STATE(568)] = 9952,
  [SMALL_STATE(569)] = 9959,
  [SMALL_STATE(570)] = 9966,
  [SMALL_STATE(571)] = 9973,
  [SMALL_STATE(572)] = 9980,
  [SMALL_STATE(573)] = 9987,
  [SMALL_STATE(574)] = 9994,
  [SMALL_STATE(575)] = 10001,
  [SMALL_STATE(576)] = 10008,
  [SMALL_STATE(577)] = 10015,
  [SMALL_STATE(578)] = 10022,
  [SMALL_STATE(579)] = 10029,
  [SMALL_STATE(580)] = 10036,
  [SMALL_STATE(581)] = 10043,
  [SMALL_STATE(582)] = 10050,
  [SMALL_STATE(583)] = 10057,
  [SMALL_STATE(584)] = 10064,
  [SMALL_STATE(585)] = 10071,
  [SMALL_STATE(586)] = 10078,
  [SMALL_STATE(587)] = 10085,
  [SMALL_STATE(588)] = 10092,
  [SMALL_STATE(589)] = 10099,
  [SMALL_STATE(590)] = 10106,
  [SMALL_STATE(591)] = 10113,
  [SMALL_STATE(592)] = 10120,
  [SMALL_STATE(593)] = 10127,
  [SMALL_STATE(594)] = 10134,
  [SMALL_STATE(595)] = 10141,
  [SMALL_STATE(596)] = 10148,
  [SMALL_STATE(597)] = 10155,
  [SMALL_STATE(598)] = 10162,
  [SMALL_STATE(599)] = 10169,
  [SMALL_STATE(600)] = 10176,
  [SMALL_STATE(601)] = 10183,
  [SMALL_STATE(602)] = 10190,
  [SMALL_STATE(603)] = 10197,
  [SMALL_STATE(604)] = 10204,
  [SMALL_STATE(605)] = 10211,
  [SMALL_STATE(606)] = 10218,
  [SMALL_STATE(607)] = 10225,
  [SMALL_STATE(608)] = 10232,
  [SMALL_STATE(609)] = 10239,
  [SMALL_STATE(610)] = 10246,
  [SMALL_STATE(611)] = 10253,
  [SMALL_STATE(612)] = 10260,
  [SMALL_STATE(613)] = 10267,
  [SMALL_STATE(614)] = 10274,
  [SMALL_STATE(615)] = 10281,
  [SMALL_STATE(616)] = 10288,
  [SMALL_STATE(617)] = 10295,
  [SMALL_STATE(618)] = 10302,
  [SMALL_STATE(619)] = 10309,
  [SMALL_STATE(620)] = 10316,
  [SMALL_STATE(621)] = 10323,
  [SMALL_STATE(622)] = 10330,
  [SMALL_STATE(623)] = 10337,
  [SMALL_STATE(624)] = 10344,
  [SMALL_STATE(625)] = 10351,
  [SMALL_STATE(626)] = 10358,
  [SMALL_STATE(627)] = 10365,
  [SMALL_STATE(628)] = 10372,
  [SMALL_STATE(629)] = 10379,
  [SMALL_STATE(630)] = 10386,
  [SMALL_STATE(631)] = 10393,
  [SMALL_STATE(632)] = 10400,
  [SMALL_STATE(633)] = 10407,
  [SMALL_STATE(634)] = 10414,
  [SMALL_STATE(635)] = 10421,
  [SMALL_STATE(636)] = 10428,
  [SMALL_STATE(637)] = 10435,
  [SMALL_STATE(638)] = 10442,
  [SMALL_STATE(639)] = 10449,
  [SMALL_STATE(640)] = 10456,
  [SMALL_STATE(641)] = 10463,
  [SMALL_STATE(642)] = 10470,
  [SMALL_STATE(643)] = 10477,
  [SMALL_STATE(644)] = 10484,
  [SMALL_STATE(645)] = 10491,
  [SMALL_STATE(646)] = 10498,
  [SMALL_STATE(647)] = 10505,
  [SMALL_STATE(648)] = 10512,
  [SMALL_STATE(649)] = 10519,
  [SMALL_STATE(650)] = 10526,
  [SMALL_STATE(651)] = 10533,
  [SMALL_STATE(652)] = 10540,
  [SMALL_STATE(653)] = 10547,
  [SMALL_STATE(654)] = 10554,
  [SMALL_STATE(655)] = 10561,
  [SMALL_STATE(656)] = 10568,
  [SMALL_STATE(657)] = 10575,
  [SMALL_STATE(658)] = 10582,
  [SMALL_STATE(659)] = 10589,
  [SMALL_STATE(660)] = 10596,
  [SMALL_STATE(661)] = 10603,
  [SMALL_STATE(662)] = 10610,
  [SMALL_STATE(663)] = 10617,
  [SMALL_STATE(664)] = 10624,
  [SMALL_STATE(665)] = 10631,
  [SMALL_STATE(666)] = 10638,
  [SMALL_STATE(667)] = 10645,
  [SMALL_STATE(668)] = 10652,
  [SMALL_STATE(669)] = 10659,
  [SMALL_STATE(670)] = 10666,
  [SMALL_STATE(671)] = 10673,
  [SMALL_STATE(672)] = 10680,
  [SMALL_STATE(673)] = 10687,
  [SMALL_STATE(674)] = 10694,
  [SMALL_STATE(675)] = 10701,
  [SMALL_STATE(676)] = 10708,
  [SMALL_STATE(677)] = 10715,
  [SMALL_STATE(678)] = 10722,
  [SMALL_STATE(679)] = 10729,
  [SMALL_STATE(680)] = 10736,
  [SMALL_STATE(681)] = 10743,
  [SMALL_STATE(682)] = 10750,
  [SMALL_STATE(683)] = 10757,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(265),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(7),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(109),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(68),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(69),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(49),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(65),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(182),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(181),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(180),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(179),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(185),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(284),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(283),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(282),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(284),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(265),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(286),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(285),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(347),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(2),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(90),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(116),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(119),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(17),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(18),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(184),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(175),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(176),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(177),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(178),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(336),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(349),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(348),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(336),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(347),
  [445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(325),
  [448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(326),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(347),
  [484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(2),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(90),
  [490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(116),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(119),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(17),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(18),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(184),
  [507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(175),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(176),
  [513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(177),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(178),
  [519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(336),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(349),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(348),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(336),
  [531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(347),
  [534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(325),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(326),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(347),
  [551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(2),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7),
  [556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(90),
  [559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(116),
  [562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(119),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(17),
  [568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(18),
  [571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(184),
  [574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(175),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(176),
  [580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(177),
  [583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(178),
  [586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(336),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(349),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(348),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(336),
  [598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(347),
  [601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(325),
  [604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(326),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1, .production_id = 5),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(347),
  [720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(2),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13),
  [725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(90),
  [728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(116),
  [731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(119),
  [734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(17),
  [737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(18),
  [740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(184),
  [743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(175),
  [746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(176),
  [749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(177),
  [752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(178),
  [755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(336),
  [758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(349),
  [761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(348),
  [764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(336),
  [767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(347),
  [770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(325),
  [773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(326),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(412),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(74),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(75),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(76),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(50),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(40),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(191),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(192),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(193),
  [810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(194),
  [813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(195),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(398),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(399),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(411),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(398),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(412),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(392),
  [834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(397),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(537),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(184),
  [1005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(175),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(176),
  [1011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(177),
  [1014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(458),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(325),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__special_forms, 1),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__special_forms, 1),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, .production_id = 26),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, .production_id = 26),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 6, .production_id = 25),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 6, .production_id = 25),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 6, .production_id = 25),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 6, .production_id = 25),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 5, .production_id = 24),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 5, .production_id = 24),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 23),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 23),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, .production_id = 21),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, .production_id = 21),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, .production_id = 20),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, .production_id = 20),
  [1060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 5, .production_id = 18),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 5, .production_id = 18),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 5, .production_id = 18),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 5, .production_id = 18),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5, .production_id = 17),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5, .production_id = 17),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, .production_id = 14),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 14),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 4, .production_id = 12),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 4, .production_id = 12),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 4),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 4),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_peg_set, 4),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_peg_set, 4),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, .production_id = 9),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, .production_id = 9),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 6, .production_id = 28),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 6, .production_id = 28),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, .production_id = 6),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, .production_id = 6),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 3),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 3),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 3),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 3),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 28),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 28),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quote, 2),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quote, 2),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_splice, 2),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_splice, 2),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quasiquote, 2),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quasiquote, 2),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 2),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 2),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 2),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 2),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 2),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 2),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specials, 1),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specials, 1),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shorthand, 1),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shorthand, 1),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_unquote, 2),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_unquote, 2),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literals, 1),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literals, 1),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_buffer_literal, 1),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_buffer_literal, 1),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_str_literal, 1),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_str_literal, 1),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 3),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 3),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 3),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 3),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 3),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 3),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 4),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 4),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 4),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 4),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 4),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 4),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, .production_id = 30),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, .production_id = 30),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 27),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 27),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 27),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 27),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 5, .production_id = 30),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 5, .production_id = 30),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 1),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 2),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 2),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(538),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(189),
  [1348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(188),
  [1351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(187),
  [1354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(186),
  [1357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(510),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(530),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1551] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_janet_external_scanner_create(void);
void tree_sitter_janet_external_scanner_destroy(void *);
bool tree_sitter_janet_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_janet_external_scanner_serialize(void *, char *);
void tree_sitter_janet_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_janet(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_janet_external_scanner_create,
      tree_sitter_janet_external_scanner_destroy,
      tree_sitter_janet_external_scanner_scan,
      tree_sitter_janet_external_scanner_serialize,
      tree_sitter_janet_external_scanner_deserialize,
    },
    .field_count = FIELD_COUNT,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .field_names = ts_field_names,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
